<!-- BEGIN: Top Bar -->
<?php
define('EXPRESSION', '/(?=[A-Z])/');
?>
<div
    class="top-bar-boxed <?php echo e(isset($class) ? $class : ''); ?> h-[70px] md:h-[65px] z-[51] border-b border-white/[0.08] mt-12 md:mt-0 -mx-3 sm:-mx-8 md:-mx-0 px-3 md:border-b-0 relative md:fixed md:inset-x-0 md:top-0 sm:px-8 md:px-10 md:pt-10 md:bg-gradient-to-b md:from-slate-100 md:to-transparent dark:md:from-darkmode-700">
    <div class="h-full flex items-center">
        <!-- BEGIN: Logo -->
        <a href="/admin/dashboard" class="logo -intro-x hidden md:flex xl:w-[180px] block">
            
            <img alt="AstroGuru image" class="logo__image w-6" src="/build/assets/images/astrotalk.png"
                style="height: 100%;width: 100%; max-width: 50px;">
            
            <span class="logo__text text-white text-lg ml-5 mt-2.5" style="vertical-align: center">
                AstroGuru
            </span>
        </a>
        <!-- END: Logo -->
        <!-- BEGIN: Breadcrumb -->
        <nav aria-label="breadcrumb" class="-intro-x h-[45px] mr-auto">
            <ol class="breadcrumb breadcrumb-light">
                <li class="breadcrumb-item"><a href="<?php echo e(route('dashboard')); ?>">Home</a></li>
                
                <?php if(Request::segment(2)): ?>
                    <li class="breadcrumb-item active" aria-current="page" style="text-transform: capitalize;">
                        <?php if(Request::segment(3)): ?>
                            <?php if(preg_match('/[A-Z]/', Request::segment(2))): ?>
                                <?php
                                $capital = preg_split(EXPRESSION, Request::segment(2));
                                $header = implode(' - ', $capital);
                                ?>
                                <a href="/admin/<?php echo e(Request::segment(2)); ?>"> <?php echo e($header); ?></a>
                            <?php else: ?>
                                <a href="/admin/<?php echo e(Request::segment(2)); ?>"> <?php echo e(Request::segment(2)); ?></a>
                            <?php endif; ?>
                    <li class="breadcrumb-item active" aria-current="page" style="text-transform: capitalize;">
                        <?php if(preg_match('/[A-Z]/', Request::segment(3))): ?>
                            <?php
                            $capital = preg_split(EXPRESSION, Request::segment(3));
                            $header = implode(' - ', $capital);
                            ?>
                            <?php echo e($header); ?>

                        <?php else: ?>
                            <?php echo e(Request::segment(3)); ?>

                        <?php endif; ?>
                    </li>
                <?php else: ?>
                    <?php if(preg_match('/[A-Z]/', Request::segment(2))): ?>
                        <?php
                        $capital = preg_split(EXPRESSION, Request::segment(2));
                        $header = implode(' - ', $capital);
                        ?>
                        <?php echo e($header); ?>

                    <?php else: ?>
                        <?php echo e(Request::segment(2)); ?>

                    <?php endif; ?>
                <?php endif; ?>
                </li>
                <?php endif; ?>
            </ol>
        </nav>
        <!-- END: Breadcrumb -->
        <!-- BEGIN: Search -->
        <div class="intro-x relative mr-3 sm:mr-6">
            <div class="search hidden sm:block">
                
                
            </div>
            
            <div class="search-result">
                <div class="search-result__content">
                    <div class="search-result__content__title">Pages</div>
                    <div class="mb-5">
                        <a href="" class="flex items-center">
                            <div
                                class="w-8 h-8 bg-success/20 dark:bg-success/10 text-success flex items-center justify-center rounded-full">
                                <i class="w-4 h-4" data-lucide="inbox"></i>
                            </div>
                            <div class="ml-3">Mail Settings</div>
                        </a>
                        <a href="" class="flex items-center mt-2">
                            <div
                                class="w-8 h-8 bg-pending/10 text-pending flex items-center justify-center rounded-full">
                                <i class="w-4 h-4" data-lucide="users"></i>
                            </div>
                            <div class="ml-3">Users & Permissions</div>
                        </a>
                        <a href="" class="flex items-center mt-2">
                            <div
                                class="w-8 h-8 bg-primary/10 dark:bg-primary/20 text-primary/80 flex items-center justify-center rounded-full">
                                <i class="w-4 h-4" data-lucide="credit-card"></i>
                            </div>
                            <div class="ml-3">Transactions Report</div>
                        </a>
                    </div>
                    <div class="search-result__content__title">Users</div>
                    <div class="mb-5">
                        <?php $__currentLoopData = array_slice($fakers, 0, 4); $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $faker): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                            <a href="" class="flex items-center mt-2">
                                <div class="w-8 h-8 image-fit">
                                    <img alt="Midone - HTML Admin Template" class="rounded-full"
                                        src="<?php echo e(asset('../build/assets/images/' . $faker['photos'][0])); ?>">
                                </div>
                                <div class="ml-3"><?php echo e($faker['users'][0]['name']); ?></div>
                                <div class="ml-auto w-48 truncate text-slate-500 text-xs text-right">
                                    <?php echo e($faker['users'][0]['email']); ?></div>
                            </a>
                        <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                    </div>
                    <div class="search-result__content__title">Products</div>
                    <?php $__currentLoopData = array_slice($fakers, 0, 4); $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $faker): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                        <a href="" class="flex items-center mt-2">
                            <div class="w-8 h-8 image-fit">
                                <img alt="Midone - HTML Admin Template" class="rounded-full"
                                    src="<?php echo e(asset('/build/assets/images/' . $faker['images'][0])); ?>">
                            </div>
                            <div class="ml-3"><?php echo e($faker['products'][0]['name']); ?></div>
                            <div class="ml-auto w-48 truncate text-slate-500 text-xs text-right">
                                <?php echo e($faker['products'][0]['category']); ?></div>
                        </a>
                    <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                </div>
            </div>
        </div>
        <!-- END: Search -->
        <!-- BEGIN: Notifications -->
        <div class="intro-x dropdown mr-4 sm:mr-6">
            
            <div class="notification-content pt-2 dropdown-menu">
                <div class="notification-content__box dropdown-content">
                    <div class="notification-content__title">Notifications</div>
                    <?php $__currentLoopData = array_slice($fakers, 0, 5); $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $key => $faker): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                        <div class="cursor-pointer relative flex items-center <?php echo e($key ? 'mt-5' : ''); ?>">
                            <div class="w-12 h-12 flex-none image-fit mr-1">
                                <img alt="Midone - HTML Admin Template" class="rounded-full"
                                    src="/build/assets/images/person.png">
                                <div
                                    class="w-3 h-3 bg-success absolute right-0 bottom-0 rounded-full border-2 border-white">
                                </div>
                            </div>
                            <div class="ml-2 overflow-hidden">
                                <div class="flex items-center">
                                    <a href="javascript:;"
                                        class="font-medium truncate mr-5"><?php echo e($faker['users'][0]['name']); ?></a>
                                    <div class="text-xs text-slate-400 ml-auto whitespace-nowrap">
                                        <?php echo e($faker['times'][0]); ?></div>
                                </div>
                                <div class="w-full truncate text-slate-500 mt-0.5">
                                    <?php echo e($faker['news'][0]['short_content']); ?></div>
                            </div>
                        </div>
                    <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                </div>
            </div>
        </div>
        <!-- END: Notifications -->
        <!-- BEGIN: Account Menu -->
        <div class="intro-x dropdown w-8 h-8">
            <div class="dropdown-toggle w-8 h-8 rounded-full overflow-hidden shadow-lg image-fit zoom-in scale-110"
                role="button" aria-expanded="false" data-tw-toggle="dropdown">
                <img alt="AstroGuru image" class="logo__image w-6" src="/build/assets/images/person.png"
                    style="height: 100%;width: 100%; max-width: 50px;">
                
            </div>
            <div class="dropdown-menu w-56">
                <ul
                    class="dropdown-content bg-primary/80 before:block before:absolute before:bg-black before:inset-0 before:rounded-md before:z-[-1] text-white">
                    <li class="p-2">
                        <div class="font-medium">Admin</div>
                        
                    </li>
                    
                    
                    
                    
                    
                    <li>
                        <hr class="dropdown-divider border-white/[0.08]">
                    </li>
                    <li>
                        <a href="<?php echo e(route('logout')); ?>" class="dropdown-item hover:bg-white/5">
                            <i data-lucide="toggle-right" class="w-4 h-4 mr-2"></i> Logout
                        </a>
                    </li>
                </ul>
            </div>
        </div>
        <!-- END: Account Menu -->
    </div>
</div>
<!-- END: Top Bar -->
<?php /**PATH D:\astro\resources\views////layout/components/top-bar.blade.php ENDPATH**/ ?>