<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/aiplatform/v1/metadata_service.proto

namespace Google\Cloud\AIPlatform\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [MetadataService.AddContextArtifactsAndExecutions][google.cloud.aiplatform.v1.MetadataService.AddContextArtifactsAndExecutions].
 *
 * Generated from protobuf message <code>google.cloud.aiplatform.v1.AddContextArtifactsAndExecutionsRequest</code>
 */
class AddContextArtifactsAndExecutionsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The resource name of the Context that the Artifacts and
     * Executions belong to. Format:
     * `projects/{project}/locations/{location}/metadataStores/{metadatastore}/contexts/{context}`
     *
     * Generated from protobuf field <code>string context = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $context = '';
    /**
     * The resource names of the Artifacts to attribute to the Context.
     * Format:
     * `projects/{project}/locations/{location}/metadataStores/{metadatastore}/artifacts/{artifact}`
     *
     * Generated from protobuf field <code>repeated string artifacts = 2 [(.google.api.resource_reference) = {</code>
     */
    private $artifacts;
    /**
     * The resource names of the Executions to associate with the
     * Context.
     * Format:
     * `projects/{project}/locations/{location}/metadataStores/{metadatastore}/executions/{execution}`
     *
     * Generated from protobuf field <code>repeated string executions = 3 [(.google.api.resource_reference) = {</code>
     */
    private $executions;

    /**
     * @param string   $context    Required. The resource name of the Context that the Artifacts and
     *                             Executions belong to. Format:
     *                             `projects/{project}/locations/{location}/metadataStores/{metadatastore}/contexts/{context}`
     *                             Please see {@see MetadataServiceClient::contextName()} for help formatting this field.
     * @param string[] $artifacts  The resource names of the Artifacts to attribute to the Context.
     *
     *                             Format:
     *                             `projects/{project}/locations/{location}/metadataStores/{metadatastore}/artifacts/{artifact}`
     * @param string[] $executions The resource names of the Executions to associate with the
     *                             Context.
     *
     *                             Format:
     *                             `projects/{project}/locations/{location}/metadataStores/{metadatastore}/executions/{execution}`
     *
     * @return \Google\Cloud\AIPlatform\V1\AddContextArtifactsAndExecutionsRequest
     *
     * @experimental
     */
    public static function build(string $context, array $artifacts, array $executions): self
    {
        return (new self())
            ->setContext($context)
            ->setArtifacts($artifacts)
            ->setExecutions($executions);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $context
     *           Required. The resource name of the Context that the Artifacts and
     *           Executions belong to. Format:
     *           `projects/{project}/locations/{location}/metadataStores/{metadatastore}/contexts/{context}`
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $artifacts
     *           The resource names of the Artifacts to attribute to the Context.
     *           Format:
     *           `projects/{project}/locations/{location}/metadataStores/{metadatastore}/artifacts/{artifact}`
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $executions
     *           The resource names of the Executions to associate with the
     *           Context.
     *           Format:
     *           `projects/{project}/locations/{location}/metadataStores/{metadatastore}/executions/{execution}`
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Aiplatform\V1\MetadataService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The resource name of the Context that the Artifacts and
     * Executions belong to. Format:
     * `projects/{project}/locations/{location}/metadataStores/{metadatastore}/contexts/{context}`
     *
     * Generated from protobuf field <code>string context = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getContext()
    {
        return $this->context;
    }

    /**
     * Required. The resource name of the Context that the Artifacts and
     * Executions belong to. Format:
     * `projects/{project}/locations/{location}/metadataStores/{metadatastore}/contexts/{context}`
     *
     * Generated from protobuf field <code>string context = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setContext($var)
    {
        GPBUtil::checkString($var, True);
        $this->context = $var;

        return $this;
    }

    /**
     * The resource names of the Artifacts to attribute to the Context.
     * Format:
     * `projects/{project}/locations/{location}/metadataStores/{metadatastore}/artifacts/{artifact}`
     *
     * Generated from protobuf field <code>repeated string artifacts = 2 [(.google.api.resource_reference) = {</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getArtifacts()
    {
        return $this->artifacts;
    }

    /**
     * The resource names of the Artifacts to attribute to the Context.
     * Format:
     * `projects/{project}/locations/{location}/metadataStores/{metadatastore}/artifacts/{artifact}`
     *
     * Generated from protobuf field <code>repeated string artifacts = 2 [(.google.api.resource_reference) = {</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setArtifacts($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->artifacts = $arr;

        return $this;
    }

    /**
     * The resource names of the Executions to associate with the
     * Context.
     * Format:
     * `projects/{project}/locations/{location}/metadataStores/{metadatastore}/executions/{execution}`
     *
     * Generated from protobuf field <code>repeated string executions = 3 [(.google.api.resource_reference) = {</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getExecutions()
    {
        return $this->executions;
    }

    /**
     * The resource names of the Executions to associate with the
     * Context.
     * Format:
     * `projects/{project}/locations/{location}/metadataStores/{metadatastore}/executions/{execution}`
     *
     * Generated from protobuf field <code>repeated string executions = 3 [(.google.api.resource_reference) = {</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setExecutions($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->executions = $arr;

        return $this;
    }

}

