<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/aiplatform/v1/featurestore_service.proto

namespace Google\Cloud\AIPlatform\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [FeaturestoreService.ExportFeatureValues][google.cloud.aiplatform.v1.FeaturestoreService.ExportFeatureValues].
 *
 * Generated from protobuf message <code>google.cloud.aiplatform.v1.ExportFeatureValuesRequest</code>
 */
class ExportFeatureValuesRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The resource name of the EntityType from which to export Feature
     * values. Format:
     * `projects/{project}/locations/{location}/featurestores/{featurestore}/entityTypes/{entity_type}`
     *
     * Generated from protobuf field <code>string entity_type = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $entity_type = '';
    /**
     * Required. Specifies destination location and format.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.FeatureValueDestination destination = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $destination = null;
    /**
     * Required. Selects Features to export values of.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.FeatureSelector feature_selector = 5 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $feature_selector = null;
    /**
     * Per-Feature export settings.
     *
     * Generated from protobuf field <code>repeated .google.cloud.aiplatform.v1.DestinationFeatureSetting settings = 6;</code>
     */
    private $settings;
    protected $mode;

    /**
     * @param string $entityType Required. The resource name of the EntityType from which to export Feature
     *                           values. Format:
     *                           `projects/{project}/locations/{location}/featurestores/{featurestore}/entityTypes/{entity_type}`
     *                           Please see {@see FeaturestoreServiceClient::entityTypeName()} for help formatting this field.
     *
     * @return \Google\Cloud\AIPlatform\V1\ExportFeatureValuesRequest
     *
     * @experimental
     */
    public static function build(string $entityType): self
    {
        return (new self())
            ->setEntityType($entityType);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Cloud\AIPlatform\V1\ExportFeatureValuesRequest\SnapshotExport $snapshot_export
     *           Exports the latest Feature values of all entities of the EntityType
     *           within a time range.
     *     @type \Google\Cloud\AIPlatform\V1\ExportFeatureValuesRequest\FullExport $full_export
     *           Exports all historical values of all entities of the EntityType within a
     *           time range
     *     @type string $entity_type
     *           Required. The resource name of the EntityType from which to export Feature
     *           values. Format:
     *           `projects/{project}/locations/{location}/featurestores/{featurestore}/entityTypes/{entity_type}`
     *     @type \Google\Cloud\AIPlatform\V1\FeatureValueDestination $destination
     *           Required. Specifies destination location and format.
     *     @type \Google\Cloud\AIPlatform\V1\FeatureSelector $feature_selector
     *           Required. Selects Features to export values of.
     *     @type array<\Google\Cloud\AIPlatform\V1\DestinationFeatureSetting>|\Google\Protobuf\Internal\RepeatedField $settings
     *           Per-Feature export settings.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Aiplatform\V1\FeaturestoreService::initOnce();
        parent::__construct($data);
    }

    /**
     * Exports the latest Feature values of all entities of the EntityType
     * within a time range.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.ExportFeatureValuesRequest.SnapshotExport snapshot_export = 3;</code>
     * @return \Google\Cloud\AIPlatform\V1\ExportFeatureValuesRequest\SnapshotExport|null
     */
    public function getSnapshotExport()
    {
        return $this->readOneof(3);
    }

    public function hasSnapshotExport()
    {
        return $this->hasOneof(3);
    }

    /**
     * Exports the latest Feature values of all entities of the EntityType
     * within a time range.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.ExportFeatureValuesRequest.SnapshotExport snapshot_export = 3;</code>
     * @param \Google\Cloud\AIPlatform\V1\ExportFeatureValuesRequest\SnapshotExport $var
     * @return $this
     */
    public function setSnapshotExport($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\ExportFeatureValuesRequest\SnapshotExport::class);
        $this->writeOneof(3, $var);

        return $this;
    }

    /**
     * Exports all historical values of all entities of the EntityType within a
     * time range
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.ExportFeatureValuesRequest.FullExport full_export = 7;</code>
     * @return \Google\Cloud\AIPlatform\V1\ExportFeatureValuesRequest\FullExport|null
     */
    public function getFullExport()
    {
        return $this->readOneof(7);
    }

    public function hasFullExport()
    {
        return $this->hasOneof(7);
    }

    /**
     * Exports all historical values of all entities of the EntityType within a
     * time range
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.ExportFeatureValuesRequest.FullExport full_export = 7;</code>
     * @param \Google\Cloud\AIPlatform\V1\ExportFeatureValuesRequest\FullExport $var
     * @return $this
     */
    public function setFullExport($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\ExportFeatureValuesRequest\FullExport::class);
        $this->writeOneof(7, $var);

        return $this;
    }

    /**
     * Required. The resource name of the EntityType from which to export Feature
     * values. Format:
     * `projects/{project}/locations/{location}/featurestores/{featurestore}/entityTypes/{entity_type}`
     *
     * Generated from protobuf field <code>string entity_type = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getEntityType()
    {
        return $this->entity_type;
    }

    /**
     * Required. The resource name of the EntityType from which to export Feature
     * values. Format:
     * `projects/{project}/locations/{location}/featurestores/{featurestore}/entityTypes/{entity_type}`
     *
     * Generated from protobuf field <code>string entity_type = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setEntityType($var)
    {
        GPBUtil::checkString($var, True);
        $this->entity_type = $var;

        return $this;
    }

    /**
     * Required. Specifies destination location and format.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.FeatureValueDestination destination = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\AIPlatform\V1\FeatureValueDestination|null
     */
    public function getDestination()
    {
        return $this->destination;
    }

    public function hasDestination()
    {
        return isset($this->destination);
    }

    public function clearDestination()
    {
        unset($this->destination);
    }

    /**
     * Required. Specifies destination location and format.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.FeatureValueDestination destination = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\AIPlatform\V1\FeatureValueDestination $var
     * @return $this
     */
    public function setDestination($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\FeatureValueDestination::class);
        $this->destination = $var;

        return $this;
    }

    /**
     * Required. Selects Features to export values of.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.FeatureSelector feature_selector = 5 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\AIPlatform\V1\FeatureSelector|null
     */
    public function getFeatureSelector()
    {
        return $this->feature_selector;
    }

    public function hasFeatureSelector()
    {
        return isset($this->feature_selector);
    }

    public function clearFeatureSelector()
    {
        unset($this->feature_selector);
    }

    /**
     * Required. Selects Features to export values of.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.FeatureSelector feature_selector = 5 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\AIPlatform\V1\FeatureSelector $var
     * @return $this
     */
    public function setFeatureSelector($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\FeatureSelector::class);
        $this->feature_selector = $var;

        return $this;
    }

    /**
     * Per-Feature export settings.
     *
     * Generated from protobuf field <code>repeated .google.cloud.aiplatform.v1.DestinationFeatureSetting settings = 6;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getSettings()
    {
        return $this->settings;
    }

    /**
     * Per-Feature export settings.
     *
     * Generated from protobuf field <code>repeated .google.cloud.aiplatform.v1.DestinationFeatureSetting settings = 6;</code>
     * @param array<\Google\Cloud\AIPlatform\V1\DestinationFeatureSetting>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setSettings($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\AIPlatform\V1\DestinationFeatureSetting::class);
        $this->settings = $arr;

        return $this;
    }

    /**
     * @return string
     */
    public function getMode()
    {
        return $this->whichOneof("mode");
    }

}

