<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/aiplatform/v1/prediction_service.proto

namespace Google\Cloud\AIPlatform\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Response message for
 * [PredictionService.Predict][google.cloud.aiplatform.v1.PredictionService.Predict].
 *
 * Generated from protobuf message <code>google.cloud.aiplatform.v1.PredictResponse</code>
 */
class PredictResponse extends \Google\Protobuf\Internal\Message
{
    /**
     * The predictions that are the output of the predictions call.
     * The schema of any single prediction may be specified via Endpoint's
     * DeployedModels' [Model's ][google.cloud.aiplatform.v1.DeployedModel.model]
     * [PredictSchemata's][google.cloud.aiplatform.v1.Model.predict_schemata]
     * [prediction_schema_uri][google.cloud.aiplatform.v1.PredictSchemata.prediction_schema_uri].
     *
     * Generated from protobuf field <code>repeated .google.protobuf.Value predictions = 1;</code>
     */
    private $predictions;
    /**
     * ID of the Endpoint's DeployedModel that served this prediction.
     *
     * Generated from protobuf field <code>string deployed_model_id = 2;</code>
     */
    private $deployed_model_id = '';
    /**
     * Output only. The resource name of the Model which is deployed as the
     * DeployedModel that this prediction hits.
     *
     * Generated from protobuf field <code>string model = 3 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     */
    private $model = '';
    /**
     * Output only. The version ID of the Model which is deployed as the
     * DeployedModel that this prediction hits.
     *
     * Generated from protobuf field <code>string model_version_id = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $model_version_id = '';
    /**
     * Output only. The [display
     * name][google.cloud.aiplatform.v1.Model.display_name] of the Model which is
     * deployed as the DeployedModel that this prediction hits.
     *
     * Generated from protobuf field <code>string model_display_name = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $model_display_name = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type array<\Google\Protobuf\Value>|\Google\Protobuf\Internal\RepeatedField $predictions
     *           The predictions that are the output of the predictions call.
     *           The schema of any single prediction may be specified via Endpoint's
     *           DeployedModels' [Model's ][google.cloud.aiplatform.v1.DeployedModel.model]
     *           [PredictSchemata's][google.cloud.aiplatform.v1.Model.predict_schemata]
     *           [prediction_schema_uri][google.cloud.aiplatform.v1.PredictSchemata.prediction_schema_uri].
     *     @type string $deployed_model_id
     *           ID of the Endpoint's DeployedModel that served this prediction.
     *     @type string $model
     *           Output only. The resource name of the Model which is deployed as the
     *           DeployedModel that this prediction hits.
     *     @type string $model_version_id
     *           Output only. The version ID of the Model which is deployed as the
     *           DeployedModel that this prediction hits.
     *     @type string $model_display_name
     *           Output only. The [display
     *           name][google.cloud.aiplatform.v1.Model.display_name] of the Model which is
     *           deployed as the DeployedModel that this prediction hits.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Aiplatform\V1\PredictionService::initOnce();
        parent::__construct($data);
    }

    /**
     * The predictions that are the output of the predictions call.
     * The schema of any single prediction may be specified via Endpoint's
     * DeployedModels' [Model's ][google.cloud.aiplatform.v1.DeployedModel.model]
     * [PredictSchemata's][google.cloud.aiplatform.v1.Model.predict_schemata]
     * [prediction_schema_uri][google.cloud.aiplatform.v1.PredictSchemata.prediction_schema_uri].
     *
     * Generated from protobuf field <code>repeated .google.protobuf.Value predictions = 1;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getPredictions()
    {
        return $this->predictions;
    }

    /**
     * The predictions that are the output of the predictions call.
     * The schema of any single prediction may be specified via Endpoint's
     * DeployedModels' [Model's ][google.cloud.aiplatform.v1.DeployedModel.model]
     * [PredictSchemata's][google.cloud.aiplatform.v1.Model.predict_schemata]
     * [prediction_schema_uri][google.cloud.aiplatform.v1.PredictSchemata.prediction_schema_uri].
     *
     * Generated from protobuf field <code>repeated .google.protobuf.Value predictions = 1;</code>
     * @param array<\Google\Protobuf\Value>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setPredictions($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Protobuf\Value::class);
        $this->predictions = $arr;

        return $this;
    }

    /**
     * ID of the Endpoint's DeployedModel that served this prediction.
     *
     * Generated from protobuf field <code>string deployed_model_id = 2;</code>
     * @return string
     */
    public function getDeployedModelId()
    {
        return $this->deployed_model_id;
    }

    /**
     * ID of the Endpoint's DeployedModel that served this prediction.
     *
     * Generated from protobuf field <code>string deployed_model_id = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setDeployedModelId($var)
    {
        GPBUtil::checkString($var, True);
        $this->deployed_model_id = $var;

        return $this;
    }

    /**
     * Output only. The resource name of the Model which is deployed as the
     * DeployedModel that this prediction hits.
     *
     * Generated from protobuf field <code>string model = 3 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getModel()
    {
        return $this->model;
    }

    /**
     * Output only. The resource name of the Model which is deployed as the
     * DeployedModel that this prediction hits.
     *
     * Generated from protobuf field <code>string model = 3 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setModel($var)
    {
        GPBUtil::checkString($var, True);
        $this->model = $var;

        return $this;
    }

    /**
     * Output only. The version ID of the Model which is deployed as the
     * DeployedModel that this prediction hits.
     *
     * Generated from protobuf field <code>string model_version_id = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getModelVersionId()
    {
        return $this->model_version_id;
    }

    /**
     * Output only. The version ID of the Model which is deployed as the
     * DeployedModel that this prediction hits.
     *
     * Generated from protobuf field <code>string model_version_id = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setModelVersionId($var)
    {
        GPBUtil::checkString($var, True);
        $this->model_version_id = $var;

        return $this;
    }

    /**
     * Output only. The [display
     * name][google.cloud.aiplatform.v1.Model.display_name] of the Model which is
     * deployed as the DeployedModel that this prediction hits.
     *
     * Generated from protobuf field <code>string model_display_name = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getModelDisplayName()
    {
        return $this->model_display_name;
    }

    /**
     * Output only. The [display
     * name][google.cloud.aiplatform.v1.Model.display_name] of the Model which is
     * deployed as the DeployedModel that this prediction hits.
     *
     * Generated from protobuf field <code>string model_display_name = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setModelDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->model_display_name = $var;

        return $this;
    }

}

