<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/batch/v1/batch.proto

namespace Google\Cloud\Batch\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * ListTasks Request.
 *
 * Generated from protobuf message <code>google.cloud.batch.v1.ListTasksRequest</code>
 */
class ListTasksRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Name of a TaskGroup from which Tasks are being requested.
     * Pattern:
     * "projects/{project}/locations/{location}/jobs/{job}/taskGroups/{task_group}"
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $parent = '';
    /**
     * Task filter, null filter matches all Tasks.
     * Filter string should be of the format State=TaskStatus.State e.g.
     * State=RUNNING
     *
     * Generated from protobuf field <code>string filter = 2;</code>
     */
    private $filter = '';
    /**
     * Page size.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     */
    private $page_size = 0;
    /**
     * Page token.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     */
    private $page_token = '';

    /**
     * @param string $parent Required. Name of a TaskGroup from which Tasks are being requested.
     *                       Pattern:
     *                       "projects/{project}/locations/{location}/jobs/{job}/taskGroups/{task_group}"
     *                       Please see {@see BatchServiceClient::taskGroupName()} for help formatting this field.
     *
     * @return \Google\Cloud\Batch\V1\ListTasksRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. Name of a TaskGroup from which Tasks are being requested.
     *           Pattern:
     *           "projects/{project}/locations/{location}/jobs/{job}/taskGroups/{task_group}"
     *     @type string $filter
     *           Task filter, null filter matches all Tasks.
     *           Filter string should be of the format State=TaskStatus.State e.g.
     *           State=RUNNING
     *     @type int $page_size
     *           Page size.
     *     @type string $page_token
     *           Page token.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Batch\V1\Batch::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Name of a TaskGroup from which Tasks are being requested.
     * Pattern:
     * "projects/{project}/locations/{location}/jobs/{job}/taskGroups/{task_group}"
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. Name of a TaskGroup from which Tasks are being requested.
     * Pattern:
     * "projects/{project}/locations/{location}/jobs/{job}/taskGroups/{task_group}"
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Task filter, null filter matches all Tasks.
     * Filter string should be of the format State=TaskStatus.State e.g.
     * State=RUNNING
     *
     * Generated from protobuf field <code>string filter = 2;</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Task filter, null filter matches all Tasks.
     * Filter string should be of the format State=TaskStatus.State e.g.
     * State=RUNNING
     *
     * Generated from protobuf field <code>string filter = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * Page size.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Page size.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Page token.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Page token.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

}

