<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/batch/v1/task.proto

namespace Google\Cloud\Batch\V1\Runnable;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Script runnable.
 *
 * Generated from protobuf message <code>google.cloud.batch.v1.Runnable.Script</code>
 */
class Script extends \Google\Protobuf\Internal\Message
{
    protected $command;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $path
     *           Script file path on the host VM.
     *           To specify an interpreter, please add a `#!<interpreter>`(also known as
     *           [shebang line](https://en.wikipedia.org/wiki/Shebang_(Unix))) as the
     *           first line of the file.(For example, to execute the script using bash,
     *           `#!/bin/bash` should be the first line of the file. To execute the
     *           script using`Python3`, `#!/usr/bin/env python3` should be the first
     *           line of the file.) Otherwise, the file will by default be excuted by
     *           `/bin/sh`.
     *     @type string $text
     *           Shell script text.
     *           To specify an interpreter, please add a `#!<interpreter>\n` at the
     *           beginning of the text.(For example, to execute the script using bash,
     *           `#!/bin/bash\n` should be added. To execute the script using`Python3`,
     *           `#!/usr/bin/env python3\n` should be added.) Otherwise, the script will
     *           by default be excuted by `/bin/sh`.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Batch\V1\Task::initOnce();
        parent::__construct($data);
    }

    /**
     * Script file path on the host VM.
     * To specify an interpreter, please add a `#!<interpreter>`(also known as
     * [shebang line](https://en.wikipedia.org/wiki/Shebang_(Unix))) as the
     * first line of the file.(For example, to execute the script using bash,
     * `#!/bin/bash` should be the first line of the file. To execute the
     * script using`Python3`, `#!/usr/bin/env python3` should be the first
     * line of the file.) Otherwise, the file will by default be excuted by
     * `/bin/sh`.
     *
     * Generated from protobuf field <code>string path = 1;</code>
     * @return string
     */
    public function getPath()
    {
        return $this->readOneof(1);
    }

    public function hasPath()
    {
        return $this->hasOneof(1);
    }

    /**
     * Script file path on the host VM.
     * To specify an interpreter, please add a `#!<interpreter>`(also known as
     * [shebang line](https://en.wikipedia.org/wiki/Shebang_(Unix))) as the
     * first line of the file.(For example, to execute the script using bash,
     * `#!/bin/bash` should be the first line of the file. To execute the
     * script using`Python3`, `#!/usr/bin/env python3` should be the first
     * line of the file.) Otherwise, the file will by default be excuted by
     * `/bin/sh`.
     *
     * Generated from protobuf field <code>string path = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setPath($var)
    {
        GPBUtil::checkString($var, True);
        $this->writeOneof(1, $var);

        return $this;
    }

    /**
     * Shell script text.
     * To specify an interpreter, please add a `#!<interpreter>\n` at the
     * beginning of the text.(For example, to execute the script using bash,
     * `#!/bin/bash\n` should be added. To execute the script using`Python3`,
     * `#!/usr/bin/env python3\n` should be added.) Otherwise, the script will
     * by default be excuted by `/bin/sh`.
     *
     * Generated from protobuf field <code>string text = 2;</code>
     * @return string
     */
    public function getText()
    {
        return $this->readOneof(2);
    }

    public function hasText()
    {
        return $this->hasOneof(2);
    }

    /**
     * Shell script text.
     * To specify an interpreter, please add a `#!<interpreter>\n` at the
     * beginning of the text.(For example, to execute the script using bash,
     * `#!/bin/bash\n` should be added. To execute the script using`Python3`,
     * `#!/usr/bin/env python3\n` should be added.) Otherwise, the script will
     * by default be excuted by `/bin/sh`.
     *
     * Generated from protobuf field <code>string text = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setText($var)
    {
        GPBUtil::checkString($var, True);
        $this->writeOneof(2, $var);

        return $this;
    }

    /**
     * @return string
     */
    public function getCommand()
    {
        return $this->whichOneof("command");
    }

}


