<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/beyondcorp/appconnections/v1/app_connections_service.proto

namespace Google\Cloud\BeyondCorp\AppConnections\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for BeyondCorp.CreateAppConnection.
 *
 * Generated from protobuf message <code>google.cloud.beyondcorp.appconnections.v1.CreateAppConnectionRequest</code>
 */
class CreateAppConnectionRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The resource project name of the AppConnection location using the
     * form: `projects/{project_id}/locations/{location_id}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $parent = '';
    /**
     * Optional. User-settable AppConnection resource ID.
     *  * Must start with a letter.
     *  * Must contain between 4-63 characters from `/[a-z][0-9]-/`.
     *  * Must end with a number or a letter.
     *
     * Generated from protobuf field <code>string app_connection_id = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $app_connection_id = '';
    /**
     * Required. A BeyondCorp AppConnection resource.
     *
     * Generated from protobuf field <code>.google.cloud.beyondcorp.appconnections.v1.AppConnection app_connection = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $app_connection = null;
    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and t
     * he request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $request_id = '';
    /**
     * Optional. If set, validates request by executing a dry-run which would not
     * alter the resource in any way.
     *
     * Generated from protobuf field <code>bool validate_only = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $validate_only = false;

    /**
     * @param string                                                   $parent          Required. The resource project name of the AppConnection location using the
     *                                                                                  form: `projects/{project_id}/locations/{location_id}`
     *                                                                                  Please see {@see AppConnectionsServiceClient::locationName()} for help formatting this field.
     * @param \Google\Cloud\BeyondCorp\AppConnections\V1\AppConnection $appConnection   Required. A BeyondCorp AppConnection resource.
     * @param string                                                   $appConnectionId Optional. User-settable AppConnection resource ID.
     *                                                                                  * Must start with a letter.
     *                                                                                  * Must contain between 4-63 characters from `/[a-z][0-9]-/`.
     *                                                                                  * Must end with a number or a letter.
     *
     * @return \Google\Cloud\BeyondCorp\AppConnections\V1\CreateAppConnectionRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\BeyondCorp\AppConnections\V1\AppConnection $appConnection, string $appConnectionId): self
    {
        return (new self())
            ->setParent($parent)
            ->setAppConnection($appConnection)
            ->setAppConnectionId($appConnectionId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The resource project name of the AppConnection location using the
     *           form: `projects/{project_id}/locations/{location_id}`
     *     @type string $app_connection_id
     *           Optional. User-settable AppConnection resource ID.
     *            * Must start with a letter.
     *            * Must contain between 4-63 characters from `/[a-z][0-9]-/`.
     *            * Must end with a number or a letter.
     *     @type \Google\Cloud\BeyondCorp\AppConnections\V1\AppConnection $app_connection
     *           Required. A BeyondCorp AppConnection resource.
     *     @type string $request_id
     *           Optional. An optional request ID to identify requests. Specify a unique
     *           request ID so that if you must retry your request, the server will know to
     *           ignore the request if it has already been completed. The server will
     *           guarantee that for at least 60 minutes since the first request.
     *           For example, consider a situation where you make an initial request and t
     *           he request times out. If you make the request again with the same request
     *           ID, the server can check if original operation with the same request ID
     *           was received, and if so, will ignore the second request. This prevents
     *           clients from accidentally creating duplicate commitments.
     *           The request ID must be a valid UUID with the exception that zero UUID is
     *           not supported (00000000-0000-0000-0000-000000000000).
     *     @type bool $validate_only
     *           Optional. If set, validates request by executing a dry-run which would not
     *           alter the resource in any way.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Beyondcorp\Appconnections\V1\AppConnectionsService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The resource project name of the AppConnection location using the
     * form: `projects/{project_id}/locations/{location_id}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The resource project name of the AppConnection location using the
     * form: `projects/{project_id}/locations/{location_id}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. User-settable AppConnection resource ID.
     *  * Must start with a letter.
     *  * Must contain between 4-63 characters from `/[a-z][0-9]-/`.
     *  * Must end with a number or a letter.
     *
     * Generated from protobuf field <code>string app_connection_id = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getAppConnectionId()
    {
        return $this->app_connection_id;
    }

    /**
     * Optional. User-settable AppConnection resource ID.
     *  * Must start with a letter.
     *  * Must contain between 4-63 characters from `/[a-z][0-9]-/`.
     *  * Must end with a number or a letter.
     *
     * Generated from protobuf field <code>string app_connection_id = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setAppConnectionId($var)
    {
        GPBUtil::checkString($var, True);
        $this->app_connection_id = $var;

        return $this;
    }

    /**
     * Required. A BeyondCorp AppConnection resource.
     *
     * Generated from protobuf field <code>.google.cloud.beyondcorp.appconnections.v1.AppConnection app_connection = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\BeyondCorp\AppConnections\V1\AppConnection|null
     */
    public function getAppConnection()
    {
        return $this->app_connection;
    }

    public function hasAppConnection()
    {
        return isset($this->app_connection);
    }

    public function clearAppConnection()
    {
        unset($this->app_connection);
    }

    /**
     * Required. A BeyondCorp AppConnection resource.
     *
     * Generated from protobuf field <code>.google.cloud.beyondcorp.appconnections.v1.AppConnection app_connection = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\BeyondCorp\AppConnections\V1\AppConnection $var
     * @return $this
     */
    public function setAppConnection($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\BeyondCorp\AppConnections\V1\AppConnection::class);
        $this->app_connection = $var;

        return $this;
    }

    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and t
     * he request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getRequestId()
    {
        return $this->request_id;
    }

    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and t
     * he request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setRequestId($var)
    {
        GPBUtil::checkString($var, True);
        $this->request_id = $var;

        return $this;
    }

    /**
     * Optional. If set, validates request by executing a dry-run which would not
     * alter the resource in any way.
     *
     * Generated from protobuf field <code>bool validate_only = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getValidateOnly()
    {
        return $this->validate_only;
    }

    /**
     * Optional. If set, validates request by executing a dry-run which would not
     * alter the resource in any way.
     *
     * Generated from protobuf field <code>bool validate_only = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setValidateOnly($var)
    {
        GPBUtil::checkBool($var);
        $this->validate_only = $var;

        return $this;
    }

}

