<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/beyondcorp/appconnectors/v1/app_connectors_service.proto

namespace Google\Cloud\BeyondCorp\AppConnectors\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for BeyondCorp.CreateAppConnector.
 *
 * Generated from protobuf message <code>google.cloud.beyondcorp.appconnectors.v1.CreateAppConnectorRequest</code>
 */
class CreateAppConnectorRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The resource project name of the AppConnector location using the
     * form: `projects/{project_id}/locations/{location_id}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $parent = '';
    /**
     * Optional. User-settable AppConnector resource ID.
     *  * Must start with a letter.
     *  * Must contain between 4-63 characters from `/[a-z][0-9]-/`.
     *  * Must end with a number or a letter.
     *
     * Generated from protobuf field <code>string app_connector_id = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $app_connector_id = '';
    /**
     * Required. A BeyondCorp AppConnector resource.
     *
     * Generated from protobuf field <code>.google.cloud.beyondcorp.appconnectors.v1.AppConnector app_connector = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $app_connector = null;
    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and t
     * he request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $request_id = '';
    /**
     * Optional. If set, validates request by executing a dry-run which would not
     * alter the resource in any way.
     *
     * Generated from protobuf field <code>bool validate_only = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $validate_only = false;

    /**
     * @param string                                                 $parent         Required. The resource project name of the AppConnector location using the
     *                                                                               form: `projects/{project_id}/locations/{location_id}`
     *                                                                               Please see {@see AppConnectorsServiceClient::locationName()} for help formatting this field.
     * @param \Google\Cloud\BeyondCorp\AppConnectors\V1\AppConnector $appConnector   Required. A BeyondCorp AppConnector resource.
     * @param string                                                 $appConnectorId Optional. User-settable AppConnector resource ID.
     *
     *                                                                               * Must start with a letter.
     *                                                                               * Must contain between 4-63 characters from `/[a-z][0-9]-/`.
     *                                                                               * Must end with a number or a letter.
     *
     * @return \Google\Cloud\BeyondCorp\AppConnectors\V1\CreateAppConnectorRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\BeyondCorp\AppConnectors\V1\AppConnector $appConnector, string $appConnectorId): self
    {
        return (new self())
            ->setParent($parent)
            ->setAppConnector($appConnector)
            ->setAppConnectorId($appConnectorId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The resource project name of the AppConnector location using the
     *           form: `projects/{project_id}/locations/{location_id}`
     *     @type string $app_connector_id
     *           Optional. User-settable AppConnector resource ID.
     *            * Must start with a letter.
     *            * Must contain between 4-63 characters from `/[a-z][0-9]-/`.
     *            * Must end with a number or a letter.
     *     @type \Google\Cloud\BeyondCorp\AppConnectors\V1\AppConnector $app_connector
     *           Required. A BeyondCorp AppConnector resource.
     *     @type string $request_id
     *           Optional. An optional request ID to identify requests. Specify a unique
     *           request ID so that if you must retry your request, the server will know to
     *           ignore the request if it has already been completed. The server will
     *           guarantee that for at least 60 minutes since the first request.
     *           For example, consider a situation where you make an initial request and t
     *           he request times out. If you make the request again with the same request
     *           ID, the server can check if original operation with the same request ID
     *           was received, and if so, will ignore the second request. This prevents
     *           clients from accidentally creating duplicate commitments.
     *           The request ID must be a valid UUID with the exception that zero UUID is
     *           not supported (00000000-0000-0000-0000-000000000000).
     *     @type bool $validate_only
     *           Optional. If set, validates request by executing a dry-run which would not
     *           alter the resource in any way.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Beyondcorp\Appconnectors\V1\AppConnectorsService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The resource project name of the AppConnector location using the
     * form: `projects/{project_id}/locations/{location_id}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The resource project name of the AppConnector location using the
     * form: `projects/{project_id}/locations/{location_id}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. User-settable AppConnector resource ID.
     *  * Must start with a letter.
     *  * Must contain between 4-63 characters from `/[a-z][0-9]-/`.
     *  * Must end with a number or a letter.
     *
     * Generated from protobuf field <code>string app_connector_id = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getAppConnectorId()
    {
        return $this->app_connector_id;
    }

    /**
     * Optional. User-settable AppConnector resource ID.
     *  * Must start with a letter.
     *  * Must contain between 4-63 characters from `/[a-z][0-9]-/`.
     *  * Must end with a number or a letter.
     *
     * Generated from protobuf field <code>string app_connector_id = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setAppConnectorId($var)
    {
        GPBUtil::checkString($var, True);
        $this->app_connector_id = $var;

        return $this;
    }

    /**
     * Required. A BeyondCorp AppConnector resource.
     *
     * Generated from protobuf field <code>.google.cloud.beyondcorp.appconnectors.v1.AppConnector app_connector = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\BeyondCorp\AppConnectors\V1\AppConnector|null
     */
    public function getAppConnector()
    {
        return $this->app_connector;
    }

    public function hasAppConnector()
    {
        return isset($this->app_connector);
    }

    public function clearAppConnector()
    {
        unset($this->app_connector);
    }

    /**
     * Required. A BeyondCorp AppConnector resource.
     *
     * Generated from protobuf field <code>.google.cloud.beyondcorp.appconnectors.v1.AppConnector app_connector = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\BeyondCorp\AppConnectors\V1\AppConnector $var
     * @return $this
     */
    public function setAppConnector($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\BeyondCorp\AppConnectors\V1\AppConnector::class);
        $this->app_connector = $var;

        return $this;
    }

    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and t
     * he request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getRequestId()
    {
        return $this->request_id;
    }

    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and t
     * he request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setRequestId($var)
    {
        GPBUtil::checkString($var, True);
        $this->request_id = $var;

        return $this;
    }

    /**
     * Optional. If set, validates request by executing a dry-run which would not
     * alter the resource in any way.
     *
     * Generated from protobuf field <code>bool validate_only = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getValidateOnly()
    {
        return $this->validate_only;
    }

    /**
     * Optional. If set, validates request by executing a dry-run which would not
     * alter the resource in any way.
     *
     * Generated from protobuf field <code>bool validate_only = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setValidateOnly($var)
    {
        GPBUtil::checkBool($var);
        $this->validate_only = $var;

        return $this;
    }

}

