<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/devtools/cloudbuild/v1/cloudbuild.proto

namespace Google\Cloud\Build\V1\PrivatePoolV1Config;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Defines the network configuration for the pool.
 *
 * Generated from protobuf message <code>google.devtools.cloudbuild.v1.PrivatePoolV1Config.NetworkConfig</code>
 */
class NetworkConfig extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Immutable. The network definition that the workers are peered
     * to. If this section is left empty, the workers will be peered to
     * `WorkerPool.project_id` on the service producer network. Must be in the
     * format `projects/{project}/global/networks/{network}`, where `{project}`
     * is a project number, such as `12345`, and `{network}` is the name of a
     * VPC network in the project. See
     * [Understanding network configuration
     * options](https://cloud.google.com/build/docs/private-pools/set-up-private-pool-environment)
     *
     * Generated from protobuf field <code>string peered_network = 1 [(.google.api.field_behavior) = IMMUTABLE, (.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $peered_network = '';
    /**
     * Option to configure network egress for the workers.
     *
     * Generated from protobuf field <code>.google.devtools.cloudbuild.v1.PrivatePoolV1Config.NetworkConfig.EgressOption egress_option = 2;</code>
     */
    private $egress_option = 0;
    /**
     * Immutable. Subnet IP range within the peered network. This is specified
     * in CIDR notation with a slash and the subnet prefix size. You can
     * optionally specify an IP address before the subnet prefix value. e.g.
     * `192.168.0.0/29` would specify an IP range starting at 192.168.0.0 with a
     * prefix size of 29 bits.
     * `/16` would specify a prefix size of 16 bits, with an automatically
     * determined IP within the peered VPC.
     * If unspecified, a value of `/24` will be used.
     *
     * Generated from protobuf field <code>string peered_network_ip_range = 3 [(.google.api.field_behavior) = IMMUTABLE];</code>
     */
    private $peered_network_ip_range = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $peered_network
     *           Required. Immutable. The network definition that the workers are peered
     *           to. If this section is left empty, the workers will be peered to
     *           `WorkerPool.project_id` on the service producer network. Must be in the
     *           format `projects/{project}/global/networks/{network}`, where `{project}`
     *           is a project number, such as `12345`, and `{network}` is the name of a
     *           VPC network in the project. See
     *           [Understanding network configuration
     *           options](https://cloud.google.com/build/docs/private-pools/set-up-private-pool-environment)
     *     @type int $egress_option
     *           Option to configure network egress for the workers.
     *     @type string $peered_network_ip_range
     *           Immutable. Subnet IP range within the peered network. This is specified
     *           in CIDR notation with a slash and the subnet prefix size. You can
     *           optionally specify an IP address before the subnet prefix value. e.g.
     *           `192.168.0.0/29` would specify an IP range starting at 192.168.0.0 with a
     *           prefix size of 29 bits.
     *           `/16` would specify a prefix size of 16 bits, with an automatically
     *           determined IP within the peered VPC.
     *           If unspecified, a value of `/24` will be used.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Devtools\Cloudbuild\V1\Cloudbuild::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Immutable. The network definition that the workers are peered
     * to. If this section is left empty, the workers will be peered to
     * `WorkerPool.project_id` on the service producer network. Must be in the
     * format `projects/{project}/global/networks/{network}`, where `{project}`
     * is a project number, such as `12345`, and `{network}` is the name of a
     * VPC network in the project. See
     * [Understanding network configuration
     * options](https://cloud.google.com/build/docs/private-pools/set-up-private-pool-environment)
     *
     * Generated from protobuf field <code>string peered_network = 1 [(.google.api.field_behavior) = IMMUTABLE, (.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getPeeredNetwork()
    {
        return $this->peered_network;
    }

    /**
     * Required. Immutable. The network definition that the workers are peered
     * to. If this section is left empty, the workers will be peered to
     * `WorkerPool.project_id` on the service producer network. Must be in the
     * format `projects/{project}/global/networks/{network}`, where `{project}`
     * is a project number, such as `12345`, and `{network}` is the name of a
     * VPC network in the project. See
     * [Understanding network configuration
     * options](https://cloud.google.com/build/docs/private-pools/set-up-private-pool-environment)
     *
     * Generated from protobuf field <code>string peered_network = 1 [(.google.api.field_behavior) = IMMUTABLE, (.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setPeeredNetwork($var)
    {
        GPBUtil::checkString($var, True);
        $this->peered_network = $var;

        return $this;
    }

    /**
     * Option to configure network egress for the workers.
     *
     * Generated from protobuf field <code>.google.devtools.cloudbuild.v1.PrivatePoolV1Config.NetworkConfig.EgressOption egress_option = 2;</code>
     * @return int
     */
    public function getEgressOption()
    {
        return $this->egress_option;
    }

    /**
     * Option to configure network egress for the workers.
     *
     * Generated from protobuf field <code>.google.devtools.cloudbuild.v1.PrivatePoolV1Config.NetworkConfig.EgressOption egress_option = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setEgressOption($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Build\V1\PrivatePoolV1Config\NetworkConfig\EgressOption::class);
        $this->egress_option = $var;

        return $this;
    }

    /**
     * Immutable. Subnet IP range within the peered network. This is specified
     * in CIDR notation with a slash and the subnet prefix size. You can
     * optionally specify an IP address before the subnet prefix value. e.g.
     * `192.168.0.0/29` would specify an IP range starting at 192.168.0.0 with a
     * prefix size of 29 bits.
     * `/16` would specify a prefix size of 16 bits, with an automatically
     * determined IP within the peered VPC.
     * If unspecified, a value of `/24` will be used.
     *
     * Generated from protobuf field <code>string peered_network_ip_range = 3 [(.google.api.field_behavior) = IMMUTABLE];</code>
     * @return string
     */
    public function getPeeredNetworkIpRange()
    {
        return $this->peered_network_ip_range;
    }

    /**
     * Immutable. Subnet IP range within the peered network. This is specified
     * in CIDR notation with a slash and the subnet prefix size. You can
     * optionally specify an IP address before the subnet prefix value. e.g.
     * `192.168.0.0/29` would specify an IP range starting at 192.168.0.0 with a
     * prefix size of 29 bits.
     * `/16` would specify a prefix size of 16 bits, with an automatically
     * determined IP within the peered VPC.
     * If unspecified, a value of `/24` will be used.
     *
     * Generated from protobuf field <code>string peered_network_ip_range = 3 [(.google.api.field_behavior) = IMMUTABLE];</code>
     * @param string $var
     * @return $this
     */
    public function setPeeredNetworkIpRange($var)
    {
        GPBUtil::checkString($var, True);
        $this->peered_network_ip_range = $var;

        return $this;
    }

}


