<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/devtools/cloudbuild/v2/repositories.proto

namespace Google\Cloud\Build\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A connection to a SCM like GitHub, GitHub Enterprise, Bitbucket Server or
 * GitLab.
 *
 * Generated from protobuf message <code>google.devtools.cloudbuild.v2.Connection</code>
 */
class Connection extends \Google\Protobuf\Internal\Message
{
    /**
     * Immutable. The resource name of the connection, in the format
     * `projects/{project}/locations/{location}/connections/{connection_id}`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IMMUTABLE];</code>
     */
    private $name = '';
    /**
     * Output only. Server assigned timestamp for when the connection was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $create_time = null;
    /**
     * Output only. Server assigned timestamp for when the connection was updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $update_time = null;
    /**
     * Output only. Installation state of the Connection.
     *
     * Generated from protobuf field <code>.google.devtools.cloudbuild.v2.InstallationState installation_state = 12 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $installation_state = null;
    /**
     * If disabled is set to true, functionality is disabled for this connection.
     * Repository based API methods and webhooks processing for repositories in
     * this connection will be disabled.
     *
     * Generated from protobuf field <code>bool disabled = 13;</code>
     */
    private $disabled = false;
    /**
     * Output only. Set to true when the connection is being set up or updated in
     * the background.
     *
     * Generated from protobuf field <code>bool reconciling = 14 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $reconciling = false;
    /**
     * Allows clients to store small amounts of arbitrary data.
     *
     * Generated from protobuf field <code>map<string, string> annotations = 15;</code>
     */
    private $annotations;
    /**
     * This checksum is computed by the server based on the value of other
     * fields, and may be sent on update and delete requests to ensure the
     * client has an up-to-date value before proceeding.
     *
     * Generated from protobuf field <code>string etag = 16;</code>
     */
    private $etag = '';
    protected $connection_config;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Immutable. The resource name of the connection, in the format
     *           `projects/{project}/locations/{location}/connections/{connection_id}`.
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. Server assigned timestamp for when the connection was created.
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Output only. Server assigned timestamp for when the connection was updated.
     *     @type \Google\Cloud\Build\V2\GitHubConfig $github_config
     *           Configuration for connections to github.com.
     *     @type \Google\Cloud\Build\V2\GitHubEnterpriseConfig $github_enterprise_config
     *           Configuration for connections to an instance of GitHub Enterprise.
     *     @type \Google\Cloud\Build\V2\InstallationState $installation_state
     *           Output only. Installation state of the Connection.
     *     @type bool $disabled
     *           If disabled is set to true, functionality is disabled for this connection.
     *           Repository based API methods and webhooks processing for repositories in
     *           this connection will be disabled.
     *     @type bool $reconciling
     *           Output only. Set to true when the connection is being set up or updated in
     *           the background.
     *     @type array|\Google\Protobuf\Internal\MapField $annotations
     *           Allows clients to store small amounts of arbitrary data.
     *     @type string $etag
     *           This checksum is computed by the server based on the value of other
     *           fields, and may be sent on update and delete requests to ensure the
     *           client has an up-to-date value before proceeding.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Devtools\Cloudbuild\V2\Repositories::initOnce();
        parent::__construct($data);
    }

    /**
     * Immutable. The resource name of the connection, in the format
     * `projects/{project}/locations/{location}/connections/{connection_id}`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IMMUTABLE];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Immutable. The resource name of the connection, in the format
     * `projects/{project}/locations/{location}/connections/{connection_id}`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IMMUTABLE];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Output only. Server assigned timestamp for when the connection was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. Server assigned timestamp for when the connection was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Output only. Server assigned timestamp for when the connection was updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Output only. Server assigned timestamp for when the connection was updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * Configuration for connections to github.com.
     *
     * Generated from protobuf field <code>.google.devtools.cloudbuild.v2.GitHubConfig github_config = 5;</code>
     * @return \Google\Cloud\Build\V2\GitHubConfig|null
     */
    public function getGithubConfig()
    {
        return $this->readOneof(5);
    }

    public function hasGithubConfig()
    {
        return $this->hasOneof(5);
    }

    /**
     * Configuration for connections to github.com.
     *
     * Generated from protobuf field <code>.google.devtools.cloudbuild.v2.GitHubConfig github_config = 5;</code>
     * @param \Google\Cloud\Build\V2\GitHubConfig $var
     * @return $this
     */
    public function setGithubConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Build\V2\GitHubConfig::class);
        $this->writeOneof(5, $var);

        return $this;
    }

    /**
     * Configuration for connections to an instance of GitHub Enterprise.
     *
     * Generated from protobuf field <code>.google.devtools.cloudbuild.v2.GitHubEnterpriseConfig github_enterprise_config = 6;</code>
     * @return \Google\Cloud\Build\V2\GitHubEnterpriseConfig|null
     */
    public function getGithubEnterpriseConfig()
    {
        return $this->readOneof(6);
    }

    public function hasGithubEnterpriseConfig()
    {
        return $this->hasOneof(6);
    }

    /**
     * Configuration for connections to an instance of GitHub Enterprise.
     *
     * Generated from protobuf field <code>.google.devtools.cloudbuild.v2.GitHubEnterpriseConfig github_enterprise_config = 6;</code>
     * @param \Google\Cloud\Build\V2\GitHubEnterpriseConfig $var
     * @return $this
     */
    public function setGithubEnterpriseConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Build\V2\GitHubEnterpriseConfig::class);
        $this->writeOneof(6, $var);

        return $this;
    }

    /**
     * Output only. Installation state of the Connection.
     *
     * Generated from protobuf field <code>.google.devtools.cloudbuild.v2.InstallationState installation_state = 12 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\Build\V2\InstallationState|null
     */
    public function getInstallationState()
    {
        return $this->installation_state;
    }

    public function hasInstallationState()
    {
        return isset($this->installation_state);
    }

    public function clearInstallationState()
    {
        unset($this->installation_state);
    }

    /**
     * Output only. Installation state of the Connection.
     *
     * Generated from protobuf field <code>.google.devtools.cloudbuild.v2.InstallationState installation_state = 12 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\Build\V2\InstallationState $var
     * @return $this
     */
    public function setInstallationState($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Build\V2\InstallationState::class);
        $this->installation_state = $var;

        return $this;
    }

    /**
     * If disabled is set to true, functionality is disabled for this connection.
     * Repository based API methods and webhooks processing for repositories in
     * this connection will be disabled.
     *
     * Generated from protobuf field <code>bool disabled = 13;</code>
     * @return bool
     */
    public function getDisabled()
    {
        return $this->disabled;
    }

    /**
     * If disabled is set to true, functionality is disabled for this connection.
     * Repository based API methods and webhooks processing for repositories in
     * this connection will be disabled.
     *
     * Generated from protobuf field <code>bool disabled = 13;</code>
     * @param bool $var
     * @return $this
     */
    public function setDisabled($var)
    {
        GPBUtil::checkBool($var);
        $this->disabled = $var;

        return $this;
    }

    /**
     * Output only. Set to true when the connection is being set up or updated in
     * the background.
     *
     * Generated from protobuf field <code>bool reconciling = 14 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return bool
     */
    public function getReconciling()
    {
        return $this->reconciling;
    }

    /**
     * Output only. Set to true when the connection is being set up or updated in
     * the background.
     *
     * Generated from protobuf field <code>bool reconciling = 14 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param bool $var
     * @return $this
     */
    public function setReconciling($var)
    {
        GPBUtil::checkBool($var);
        $this->reconciling = $var;

        return $this;
    }

    /**
     * Allows clients to store small amounts of arbitrary data.
     *
     * Generated from protobuf field <code>map<string, string> annotations = 15;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getAnnotations()
    {
        return $this->annotations;
    }

    /**
     * Allows clients to store small amounts of arbitrary data.
     *
     * Generated from protobuf field <code>map<string, string> annotations = 15;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setAnnotations($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->annotations = $arr;

        return $this;
    }

    /**
     * This checksum is computed by the server based on the value of other
     * fields, and may be sent on update and delete requests to ensure the
     * client has an up-to-date value before proceeding.
     *
     * Generated from protobuf field <code>string etag = 16;</code>
     * @return string
     */
    public function getEtag()
    {
        return $this->etag;
    }

    /**
     * This checksum is computed by the server based on the value of other
     * fields, and may be sent on update and delete requests to ensure the
     * client has an up-to-date value before proceeding.
     *
     * Generated from protobuf field <code>string etag = 16;</code>
     * @param string $var
     * @return $this
     */
    public function setEtag($var)
    {
        GPBUtil::checkString($var, True);
        $this->etag = $var;

        return $this;
    }

    /**
     * @return string
     */
    public function getConnectionConfig()
    {
        return $this->whichOneof("connection_config");
    }

}

