<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/devtools/cloudbuild/v2/repositories.proto

namespace Google\Cloud\Build\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Message for updating a Connection.
 *
 * Generated from protobuf message <code>google.devtools.cloudbuild.v2.UpdateConnectionRequest</code>
 */
class UpdateConnectionRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The Connection to update.
     *
     * Generated from protobuf field <code>.google.devtools.cloudbuild.v2.Connection connection = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $connection = null;
    /**
     * The list of fields to be updated.
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask update_mask = 2;</code>
     */
    private $update_mask = null;
    /**
     * If set to true, and the connection is not found a new connection
     * will be created. In this situation `update_mask` is ignored.
     * The creation will succeed only if the input connection has all the
     * necessary information (e.g a github_config with both  user_oauth_token and
     * installation_id properties).
     *
     * Generated from protobuf field <code>bool allow_missing = 3;</code>
     */
    private $allow_missing = false;
    /**
     * The current etag of the connection.
     * If an etag is provided and does not match the current etag of the
     * connection, update will be blocked and an ABORTED error will be returned.
     *
     * Generated from protobuf field <code>string etag = 4;</code>
     */
    private $etag = '';

    /**
     * @param \Google\Cloud\Build\V2\Connection $connection Required. The Connection to update.
     * @param \Google\Protobuf\FieldMask        $updateMask The list of fields to be updated.
     *
     * @return \Google\Cloud\Build\V2\UpdateConnectionRequest
     *
     * @experimental
     */
    public static function build(\Google\Cloud\Build\V2\Connection $connection, \Google\Protobuf\FieldMask $updateMask): self
    {
        return (new self())
            ->setConnection($connection)
            ->setUpdateMask($updateMask);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Cloud\Build\V2\Connection $connection
     *           Required. The Connection to update.
     *     @type \Google\Protobuf\FieldMask $update_mask
     *           The list of fields to be updated.
     *     @type bool $allow_missing
     *           If set to true, and the connection is not found a new connection
     *           will be created. In this situation `update_mask` is ignored.
     *           The creation will succeed only if the input connection has all the
     *           necessary information (e.g a github_config with both  user_oauth_token and
     *           installation_id properties).
     *     @type string $etag
     *           The current etag of the connection.
     *           If an etag is provided and does not match the current etag of the
     *           connection, update will be blocked and an ABORTED error will be returned.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Devtools\Cloudbuild\V2\Repositories::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The Connection to update.
     *
     * Generated from protobuf field <code>.google.devtools.cloudbuild.v2.Connection connection = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\Build\V2\Connection|null
     */
    public function getConnection()
    {
        return $this->connection;
    }

    public function hasConnection()
    {
        return isset($this->connection);
    }

    public function clearConnection()
    {
        unset($this->connection);
    }

    /**
     * Required. The Connection to update.
     *
     * Generated from protobuf field <code>.google.devtools.cloudbuild.v2.Connection connection = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\Build\V2\Connection $var
     * @return $this
     */
    public function setConnection($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Build\V2\Connection::class);
        $this->connection = $var;

        return $this;
    }

    /**
     * The list of fields to be updated.
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask update_mask = 2;</code>
     * @return \Google\Protobuf\FieldMask|null
     */
    public function getUpdateMask()
    {
        return $this->update_mask;
    }

    public function hasUpdateMask()
    {
        return isset($this->update_mask);
    }

    public function clearUpdateMask()
    {
        unset($this->update_mask);
    }

    /**
     * The list of fields to be updated.
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask update_mask = 2;</code>
     * @param \Google\Protobuf\FieldMask $var
     * @return $this
     */
    public function setUpdateMask($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\FieldMask::class);
        $this->update_mask = $var;

        return $this;
    }

    /**
     * If set to true, and the connection is not found a new connection
     * will be created. In this situation `update_mask` is ignored.
     * The creation will succeed only if the input connection has all the
     * necessary information (e.g a github_config with both  user_oauth_token and
     * installation_id properties).
     *
     * Generated from protobuf field <code>bool allow_missing = 3;</code>
     * @return bool
     */
    public function getAllowMissing()
    {
        return $this->allow_missing;
    }

    /**
     * If set to true, and the connection is not found a new connection
     * will be created. In this situation `update_mask` is ignored.
     * The creation will succeed only if the input connection has all the
     * necessary information (e.g a github_config with both  user_oauth_token and
     * installation_id properties).
     *
     * Generated from protobuf field <code>bool allow_missing = 3;</code>
     * @param bool $var
     * @return $this
     */
    public function setAllowMissing($var)
    {
        GPBUtil::checkBool($var);
        $this->allow_missing = $var;

        return $this;
    }

    /**
     * The current etag of the connection.
     * If an etag is provided and does not match the current etag of the
     * connection, update will be blocked and an ABORTED error will be returned.
     *
     * Generated from protobuf field <code>string etag = 4;</code>
     * @return string
     */
    public function getEtag()
    {
        return $this->etag;
    }

    /**
     * The current etag of the connection.
     * If an etag is provided and does not match the current etag of the
     * connection, update will be blocked and an ABORTED error will be returned.
     *
     * Generated from protobuf field <code>string etag = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setEtag($var)
    {
        GPBUtil::checkString($var, True);
        $this->etag = $var;

        return $this;
    }

}

