<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dataform/v1beta1/dataform.proto

namespace Google\Cloud\Dataform\V1beta1\CompilationResult;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Configures various aspects of Dataform code compilation.
 *
 * Generated from protobuf message <code>google.cloud.dataform.v1beta1.CompilationResult.CodeCompilationConfig</code>
 */
class CodeCompilationConfig extends \Google\Protobuf\Internal\Message
{
    /**
     * Optional. The default database (Google Cloud project ID).
     *
     * Generated from protobuf field <code>string default_database = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $default_database = '';
    /**
     * Optional. The default schema (BigQuery dataset ID).
     *
     * Generated from protobuf field <code>string default_schema = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $default_schema = '';
    /**
     * Optional. The default BigQuery location to use. Defaults to "US".
     * See the BigQuery docs for a full list of locations:
     * https://cloud.google.com/bigquery/docs/locations.
     *
     * Generated from protobuf field <code>string default_location = 8 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $default_location = '';
    /**
     * Optional. The default schema (BigQuery dataset ID) for assertions.
     *
     * Generated from protobuf field <code>string assertion_schema = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $assertion_schema = '';
    /**
     * Optional. User-defined variables that are made available to project code during
     * compilation.
     *
     * Generated from protobuf field <code>map<string, string> vars = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $vars;
    /**
     * Optional. The suffix that should be appended to all database (Google Cloud project
     * ID) names.
     *
     * Generated from protobuf field <code>string database_suffix = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $database_suffix = '';
    /**
     * Optional. The suffix that should be appended to all schema (BigQuery dataset ID)
     * names.
     *
     * Generated from protobuf field <code>string schema_suffix = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $schema_suffix = '';
    /**
     * Optional. The prefix that should be prepended to all table names.
     *
     * Generated from protobuf field <code>string table_prefix = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $table_prefix = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $default_database
     *           Optional. The default database (Google Cloud project ID).
     *     @type string $default_schema
     *           Optional. The default schema (BigQuery dataset ID).
     *     @type string $default_location
     *           Optional. The default BigQuery location to use. Defaults to "US".
     *           See the BigQuery docs for a full list of locations:
     *           https://cloud.google.com/bigquery/docs/locations.
     *     @type string $assertion_schema
     *           Optional. The default schema (BigQuery dataset ID) for assertions.
     *     @type array|\Google\Protobuf\Internal\MapField $vars
     *           Optional. User-defined variables that are made available to project code during
     *           compilation.
     *     @type string $database_suffix
     *           Optional. The suffix that should be appended to all database (Google Cloud project
     *           ID) names.
     *     @type string $schema_suffix
     *           Optional. The suffix that should be appended to all schema (BigQuery dataset ID)
     *           names.
     *     @type string $table_prefix
     *           Optional. The prefix that should be prepended to all table names.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dataform\V1Beta1\Dataform::initOnce();
        parent::__construct($data);
    }

    /**
     * Optional. The default database (Google Cloud project ID).
     *
     * Generated from protobuf field <code>string default_database = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getDefaultDatabase()
    {
        return $this->default_database;
    }

    /**
     * Optional. The default database (Google Cloud project ID).
     *
     * Generated from protobuf field <code>string default_database = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setDefaultDatabase($var)
    {
        GPBUtil::checkString($var, True);
        $this->default_database = $var;

        return $this;
    }

    /**
     * Optional. The default schema (BigQuery dataset ID).
     *
     * Generated from protobuf field <code>string default_schema = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getDefaultSchema()
    {
        return $this->default_schema;
    }

    /**
     * Optional. The default schema (BigQuery dataset ID).
     *
     * Generated from protobuf field <code>string default_schema = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setDefaultSchema($var)
    {
        GPBUtil::checkString($var, True);
        $this->default_schema = $var;

        return $this;
    }

    /**
     * Optional. The default BigQuery location to use. Defaults to "US".
     * See the BigQuery docs for a full list of locations:
     * https://cloud.google.com/bigquery/docs/locations.
     *
     * Generated from protobuf field <code>string default_location = 8 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getDefaultLocation()
    {
        return $this->default_location;
    }

    /**
     * Optional. The default BigQuery location to use. Defaults to "US".
     * See the BigQuery docs for a full list of locations:
     * https://cloud.google.com/bigquery/docs/locations.
     *
     * Generated from protobuf field <code>string default_location = 8 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setDefaultLocation($var)
    {
        GPBUtil::checkString($var, True);
        $this->default_location = $var;

        return $this;
    }

    /**
     * Optional. The default schema (BigQuery dataset ID) for assertions.
     *
     * Generated from protobuf field <code>string assertion_schema = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getAssertionSchema()
    {
        return $this->assertion_schema;
    }

    /**
     * Optional. The default schema (BigQuery dataset ID) for assertions.
     *
     * Generated from protobuf field <code>string assertion_schema = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setAssertionSchema($var)
    {
        GPBUtil::checkString($var, True);
        $this->assertion_schema = $var;

        return $this;
    }

    /**
     * Optional. User-defined variables that are made available to project code during
     * compilation.
     *
     * Generated from protobuf field <code>map<string, string> vars = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getVars()
    {
        return $this->vars;
    }

    /**
     * Optional. User-defined variables that are made available to project code during
     * compilation.
     *
     * Generated from protobuf field <code>map<string, string> vars = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setVars($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->vars = $arr;

        return $this;
    }

    /**
     * Optional. The suffix that should be appended to all database (Google Cloud project
     * ID) names.
     *
     * Generated from protobuf field <code>string database_suffix = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getDatabaseSuffix()
    {
        return $this->database_suffix;
    }

    /**
     * Optional. The suffix that should be appended to all database (Google Cloud project
     * ID) names.
     *
     * Generated from protobuf field <code>string database_suffix = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setDatabaseSuffix($var)
    {
        GPBUtil::checkString($var, True);
        $this->database_suffix = $var;

        return $this;
    }

    /**
     * Optional. The suffix that should be appended to all schema (BigQuery dataset ID)
     * names.
     *
     * Generated from protobuf field <code>string schema_suffix = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getSchemaSuffix()
    {
        return $this->schema_suffix;
    }

    /**
     * Optional. The suffix that should be appended to all schema (BigQuery dataset ID)
     * names.
     *
     * Generated from protobuf field <code>string schema_suffix = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setSchemaSuffix($var)
    {
        GPBUtil::checkString($var, True);
        $this->schema_suffix = $var;

        return $this;
    }

    /**
     * Optional. The prefix that should be prepended to all table names.
     *
     * Generated from protobuf field <code>string table_prefix = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getTablePrefix()
    {
        return $this->table_prefix;
    }

    /**
     * Optional. The prefix that should be prepended to all table names.
     *
     * Generated from protobuf field <code>string table_prefix = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setTablePrefix($var)
    {
        GPBUtil::checkString($var, True);
        $this->table_prefix = $var;

        return $this;
    }

}


