<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dataplex/v1/tasks.proto

namespace Google\Cloud\Dataplex\V1\Task;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Config for running scheduled notebooks.
 *
 * Generated from protobuf message <code>google.cloud.dataplex.v1.Task.NotebookTaskConfig</code>
 */
class NotebookTaskConfig extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Path to input notebook. This can be the Cloud Storage URI of
     * the notebook file or the path to a Notebook Content. The execution args
     * are accessible as environment variables
     * (`TASK_key=value`).
     *
     * Generated from protobuf field <code>string notebook = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $notebook = '';
    /**
     * Optional. Infrastructure specification for the execution.
     *
     * Generated from protobuf field <code>.google.cloud.dataplex.v1.Task.InfrastructureSpec infrastructure_spec = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $infrastructure_spec = null;
    /**
     * Optional. Cloud Storage URIs of files to be placed in the working
     * directory of each executor.
     *
     * Generated from protobuf field <code>repeated string file_uris = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $file_uris;
    /**
     * Optional. Cloud Storage URIs of archives to be extracted into the working
     * directory of each executor. Supported file types: .jar, .tar, .tar.gz,
     * .tgz, and .zip.
     *
     * Generated from protobuf field <code>repeated string archive_uris = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $archive_uris;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $notebook
     *           Required. Path to input notebook. This can be the Cloud Storage URI of
     *           the notebook file or the path to a Notebook Content. The execution args
     *           are accessible as environment variables
     *           (`TASK_key=value`).
     *     @type \Google\Cloud\Dataplex\V1\Task\InfrastructureSpec $infrastructure_spec
     *           Optional. Infrastructure specification for the execution.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $file_uris
     *           Optional. Cloud Storage URIs of files to be placed in the working
     *           directory of each executor.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $archive_uris
     *           Optional. Cloud Storage URIs of archives to be extracted into the working
     *           directory of each executor. Supported file types: .jar, .tar, .tar.gz,
     *           .tgz, and .zip.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dataplex\V1\Tasks::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Path to input notebook. This can be the Cloud Storage URI of
     * the notebook file or the path to a Notebook Content. The execution args
     * are accessible as environment variables
     * (`TASK_key=value`).
     *
     * Generated from protobuf field <code>string notebook = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getNotebook()
    {
        return $this->notebook;
    }

    /**
     * Required. Path to input notebook. This can be the Cloud Storage URI of
     * the notebook file or the path to a Notebook Content. The execution args
     * are accessible as environment variables
     * (`TASK_key=value`).
     *
     * Generated from protobuf field <code>string notebook = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setNotebook($var)
    {
        GPBUtil::checkString($var, True);
        $this->notebook = $var;

        return $this;
    }

    /**
     * Optional. Infrastructure specification for the execution.
     *
     * Generated from protobuf field <code>.google.cloud.dataplex.v1.Task.InfrastructureSpec infrastructure_spec = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\Dataplex\V1\Task\InfrastructureSpec|null
     */
    public function getInfrastructureSpec()
    {
        return $this->infrastructure_spec;
    }

    public function hasInfrastructureSpec()
    {
        return isset($this->infrastructure_spec);
    }

    public function clearInfrastructureSpec()
    {
        unset($this->infrastructure_spec);
    }

    /**
     * Optional. Infrastructure specification for the execution.
     *
     * Generated from protobuf field <code>.google.cloud.dataplex.v1.Task.InfrastructureSpec infrastructure_spec = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\Dataplex\V1\Task\InfrastructureSpec $var
     * @return $this
     */
    public function setInfrastructureSpec($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dataplex\V1\Task\InfrastructureSpec::class);
        $this->infrastructure_spec = $var;

        return $this;
    }

    /**
     * Optional. Cloud Storage URIs of files to be placed in the working
     * directory of each executor.
     *
     * Generated from protobuf field <code>repeated string file_uris = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getFileUris()
    {
        return $this->file_uris;
    }

    /**
     * Optional. Cloud Storage URIs of files to be placed in the working
     * directory of each executor.
     *
     * Generated from protobuf field <code>repeated string file_uris = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setFileUris($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->file_uris = $arr;

        return $this;
    }

    /**
     * Optional. Cloud Storage URIs of archives to be extracted into the working
     * directory of each executor. Supported file types: .jar, .tar, .tar.gz,
     * .tgz, and .zip.
     *
     * Generated from protobuf field <code>repeated string archive_uris = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getArchiveUris()
    {
        return $this->archive_uris;
    }

    /**
     * Optional. Cloud Storage URIs of archives to be extracted into the working
     * directory of each executor. Supported file types: .jar, .tar, .tar.gz,
     * .tgz, and .zip.
     *
     * Generated from protobuf field <code>repeated string archive_uris = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setArchiveUris($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->archive_uris = $arr;

        return $this;
    }

}


