<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/discoveryengine/v1beta/document_service.proto

namespace Google\Cloud\DiscoveryEngine\V1beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [DocumentService.CreateDocument][google.cloud.discoveryengine.v1beta.DocumentService.CreateDocument]
 * method.
 *
 * Generated from protobuf message <code>google.cloud.discoveryengine.v1beta.CreateDocumentRequest</code>
 */
class CreateDocumentRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent resource name, such as
     * `projects/{project}/locations/{location}/collections/{collection}/dataStores/{data_store}/branches/{branch}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. The [Document][google.cloud.discoveryengine.v1beta.Document] to
     * create.
     *
     * Generated from protobuf field <code>.google.cloud.discoveryengine.v1beta.Document document = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $document = null;
    /**
     * Required. The ID to use for the
     * [Document][google.cloud.discoveryengine.v1beta.Document], which will become
     * the final component of the
     * [Document.name][google.cloud.discoveryengine.v1beta.Document.name].
     * If the caller does not have permission to create the
     * [Document][google.cloud.discoveryengine.v1beta.Document], regardless of
     * whether or not it exists, a `PERMISSION_DENIED` error is returned.
     * This field must be unique among all
     * [Document][google.cloud.discoveryengine.v1beta.Document]s with the same
     * [parent][google.cloud.discoveryengine.v1beta.CreateDocumentRequest.parent].
     * Otherwise, an `ALREADY_EXISTS` error is returned.
     * This field must conform to [RFC-1034](https://tools.ietf.org/html/rfc1034)
     * standard with a length limit of 63 characters. Otherwise, an
     * `INVALID_ARGUMENT` error is returned.
     *
     * Generated from protobuf field <code>string document_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $document_id = '';

    /**
     * @param string                                        $parent     Required. The parent resource name, such as
     *                                                                  `projects/{project}/locations/{location}/collections/{collection}/dataStores/{data_store}/branches/{branch}`. Please see
     *                                                                  {@see DocumentServiceClient::branchName()} for help formatting this field.
     * @param \Google\Cloud\DiscoveryEngine\V1beta\Document $document   Required. The [Document][google.cloud.discoveryengine.v1beta.Document] to
     *                                                                  create.
     * @param string                                        $documentId Required. The ID to use for the
     *                                                                  [Document][google.cloud.discoveryengine.v1beta.Document], which will become
     *                                                                  the final component of the
     *                                                                  [Document.name][google.cloud.discoveryengine.v1beta.Document.name].
     *
     *                                                                  If the caller does not have permission to create the
     *                                                                  [Document][google.cloud.discoveryengine.v1beta.Document], regardless of
     *                                                                  whether or not it exists, a `PERMISSION_DENIED` error is returned.
     *
     *                                                                  This field must be unique among all
     *                                                                  [Document][google.cloud.discoveryengine.v1beta.Document]s with the same
     *                                                                  [parent][google.cloud.discoveryengine.v1beta.CreateDocumentRequest.parent].
     *                                                                  Otherwise, an `ALREADY_EXISTS` error is returned.
     *
     *                                                                  This field must conform to [RFC-1034](https://tools.ietf.org/html/rfc1034)
     *                                                                  standard with a length limit of 63 characters. Otherwise, an
     *                                                                  `INVALID_ARGUMENT` error is returned.
     *
     * @return \Google\Cloud\DiscoveryEngine\V1beta\CreateDocumentRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\DiscoveryEngine\V1beta\Document $document, string $documentId): self
    {
        return (new self())
            ->setParent($parent)
            ->setDocument($document)
            ->setDocumentId($documentId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent resource name, such as
     *           `projects/{project}/locations/{location}/collections/{collection}/dataStores/{data_store}/branches/{branch}`.
     *     @type \Google\Cloud\DiscoveryEngine\V1beta\Document $document
     *           Required. The [Document][google.cloud.discoveryengine.v1beta.Document] to
     *           create.
     *     @type string $document_id
     *           Required. The ID to use for the
     *           [Document][google.cloud.discoveryengine.v1beta.Document], which will become
     *           the final component of the
     *           [Document.name][google.cloud.discoveryengine.v1beta.Document.name].
     *           If the caller does not have permission to create the
     *           [Document][google.cloud.discoveryengine.v1beta.Document], regardless of
     *           whether or not it exists, a `PERMISSION_DENIED` error is returned.
     *           This field must be unique among all
     *           [Document][google.cloud.discoveryengine.v1beta.Document]s with the same
     *           [parent][google.cloud.discoveryengine.v1beta.CreateDocumentRequest.parent].
     *           Otherwise, an `ALREADY_EXISTS` error is returned.
     *           This field must conform to [RFC-1034](https://tools.ietf.org/html/rfc1034)
     *           standard with a length limit of 63 characters. Otherwise, an
     *           `INVALID_ARGUMENT` error is returned.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Discoveryengine\V1Beta\DocumentService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent resource name, such as
     * `projects/{project}/locations/{location}/collections/{collection}/dataStores/{data_store}/branches/{branch}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent resource name, such as
     * `projects/{project}/locations/{location}/collections/{collection}/dataStores/{data_store}/branches/{branch}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The [Document][google.cloud.discoveryengine.v1beta.Document] to
     * create.
     *
     * Generated from protobuf field <code>.google.cloud.discoveryengine.v1beta.Document document = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\DiscoveryEngine\V1beta\Document|null
     */
    public function getDocument()
    {
        return $this->document;
    }

    public function hasDocument()
    {
        return isset($this->document);
    }

    public function clearDocument()
    {
        unset($this->document);
    }

    /**
     * Required. The [Document][google.cloud.discoveryengine.v1beta.Document] to
     * create.
     *
     * Generated from protobuf field <code>.google.cloud.discoveryengine.v1beta.Document document = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\DiscoveryEngine\V1beta\Document $var
     * @return $this
     */
    public function setDocument($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\DiscoveryEngine\V1beta\Document::class);
        $this->document = $var;

        return $this;
    }

    /**
     * Required. The ID to use for the
     * [Document][google.cloud.discoveryengine.v1beta.Document], which will become
     * the final component of the
     * [Document.name][google.cloud.discoveryengine.v1beta.Document.name].
     * If the caller does not have permission to create the
     * [Document][google.cloud.discoveryengine.v1beta.Document], regardless of
     * whether or not it exists, a `PERMISSION_DENIED` error is returned.
     * This field must be unique among all
     * [Document][google.cloud.discoveryengine.v1beta.Document]s with the same
     * [parent][google.cloud.discoveryengine.v1beta.CreateDocumentRequest.parent].
     * Otherwise, an `ALREADY_EXISTS` error is returned.
     * This field must conform to [RFC-1034](https://tools.ietf.org/html/rfc1034)
     * standard with a length limit of 63 characters. Otherwise, an
     * `INVALID_ARGUMENT` error is returned.
     *
     * Generated from protobuf field <code>string document_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getDocumentId()
    {
        return $this->document_id;
    }

    /**
     * Required. The ID to use for the
     * [Document][google.cloud.discoveryengine.v1beta.Document], which will become
     * the final component of the
     * [Document.name][google.cloud.discoveryengine.v1beta.Document.name].
     * If the caller does not have permission to create the
     * [Document][google.cloud.discoveryengine.v1beta.Document], regardless of
     * whether or not it exists, a `PERMISSION_DENIED` error is returned.
     * This field must be unique among all
     * [Document][google.cloud.discoveryengine.v1beta.Document]s with the same
     * [parent][google.cloud.discoveryengine.v1beta.CreateDocumentRequest.parent].
     * Otherwise, an `ALREADY_EXISTS` error is returned.
     * This field must conform to [RFC-1034](https://tools.ietf.org/html/rfc1034)
     * standard with a length limit of 63 characters. Otherwise, an
     * `INVALID_ARGUMENT` error is returned.
     *
     * Generated from protobuf field <code>string document_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setDocumentId($var)
    {
        GPBUtil::checkString($var, True);
        $this->document_id = $var;

        return $this;
    }

}

