<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/discoveryengine/v1beta/user_event.proto

namespace Google\Cloud\DiscoveryEngine\V1beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Detailed search information.
 *
 * Generated from protobuf message <code>google.cloud.discoveryengine.v1beta.SearchInfo</code>
 */
class SearchInfo extends \Google\Protobuf\Internal\Message
{
    /**
     * The user's search query.
     * See
     * [SearchRequest.query][google.cloud.discoveryengine.v1beta.SearchRequest.query]
     * for definition.
     * The value must be a UTF-8 encoded string with a length limit of 5,000
     * characters. Otherwise, an INVALID_ARGUMENT error is returned.
     * At least one of
     * [search_query][google.cloud.discoveryengine.v1beta.SearchInfo.search_query]
     * or
     * [PageInfo.page_category][google.cloud.discoveryengine.v1beta.PageInfo.page_category]
     * is required for `search` events. Other event types should not set this
     * field. Otherwise, an INVALID_ARGUMENT error is returned.
     *
     * Generated from protobuf field <code>string search_query = 1;</code>
     */
    protected $search_query = '';
    /**
     * The order in which products are returned, if applicable.
     * See
     * [SearchRequest.order_by][google.cloud.discoveryengine.v1beta.SearchRequest.order_by]
     * for definition and syntax.
     * The value must be a UTF-8 encoded string with a length limit of 1,000
     * characters. Otherwise, an INVALID_ARGUMENT error is returned.
     * This can only be set for `search` events. Other event types should not set
     * this field. Otherwise, an INVALID_ARGUMENT error is returned.
     *
     * Generated from protobuf field <code>string order_by = 2;</code>
     */
    protected $order_by = '';
    /**
     * An integer that specifies the current offset for pagination (the 0-indexed
     * starting location, amongst the products deemed by the API as relevant).
     * See
     * [SearchRequest.offset][google.cloud.discoveryengine.v1beta.SearchRequest.offset]
     * for definition.
     * If this field is negative, an INVALID_ARGUMENT is returned.
     * This can only be set for `search` events. Other event types should not set
     * this field. Otherwise, an INVALID_ARGUMENT error is returned.
     *
     * Generated from protobuf field <code>optional int32 offset = 3;</code>
     */
    protected $offset = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $search_query
     *           The user's search query.
     *           See
     *           [SearchRequest.query][google.cloud.discoveryengine.v1beta.SearchRequest.query]
     *           for definition.
     *           The value must be a UTF-8 encoded string with a length limit of 5,000
     *           characters. Otherwise, an INVALID_ARGUMENT error is returned.
     *           At least one of
     *           [search_query][google.cloud.discoveryengine.v1beta.SearchInfo.search_query]
     *           or
     *           [PageInfo.page_category][google.cloud.discoveryengine.v1beta.PageInfo.page_category]
     *           is required for `search` events. Other event types should not set this
     *           field. Otherwise, an INVALID_ARGUMENT error is returned.
     *     @type string $order_by
     *           The order in which products are returned, if applicable.
     *           See
     *           [SearchRequest.order_by][google.cloud.discoveryengine.v1beta.SearchRequest.order_by]
     *           for definition and syntax.
     *           The value must be a UTF-8 encoded string with a length limit of 1,000
     *           characters. Otherwise, an INVALID_ARGUMENT error is returned.
     *           This can only be set for `search` events. Other event types should not set
     *           this field. Otherwise, an INVALID_ARGUMENT error is returned.
     *     @type int $offset
     *           An integer that specifies the current offset for pagination (the 0-indexed
     *           starting location, amongst the products deemed by the API as relevant).
     *           See
     *           [SearchRequest.offset][google.cloud.discoveryengine.v1beta.SearchRequest.offset]
     *           for definition.
     *           If this field is negative, an INVALID_ARGUMENT is returned.
     *           This can only be set for `search` events. Other event types should not set
     *           this field. Otherwise, an INVALID_ARGUMENT error is returned.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Discoveryengine\V1Beta\UserEvent::initOnce();
        parent::__construct($data);
    }

    /**
     * The user's search query.
     * See
     * [SearchRequest.query][google.cloud.discoveryengine.v1beta.SearchRequest.query]
     * for definition.
     * The value must be a UTF-8 encoded string with a length limit of 5,000
     * characters. Otherwise, an INVALID_ARGUMENT error is returned.
     * At least one of
     * [search_query][google.cloud.discoveryengine.v1beta.SearchInfo.search_query]
     * or
     * [PageInfo.page_category][google.cloud.discoveryengine.v1beta.PageInfo.page_category]
     * is required for `search` events. Other event types should not set this
     * field. Otherwise, an INVALID_ARGUMENT error is returned.
     *
     * Generated from protobuf field <code>string search_query = 1;</code>
     * @return string
     */
    public function getSearchQuery()
    {
        return $this->search_query;
    }

    /**
     * The user's search query.
     * See
     * [SearchRequest.query][google.cloud.discoveryengine.v1beta.SearchRequest.query]
     * for definition.
     * The value must be a UTF-8 encoded string with a length limit of 5,000
     * characters. Otherwise, an INVALID_ARGUMENT error is returned.
     * At least one of
     * [search_query][google.cloud.discoveryengine.v1beta.SearchInfo.search_query]
     * or
     * [PageInfo.page_category][google.cloud.discoveryengine.v1beta.PageInfo.page_category]
     * is required for `search` events. Other event types should not set this
     * field. Otherwise, an INVALID_ARGUMENT error is returned.
     *
     * Generated from protobuf field <code>string search_query = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setSearchQuery($var)
    {
        GPBUtil::checkString($var, True);
        $this->search_query = $var;

        return $this;
    }

    /**
     * The order in which products are returned, if applicable.
     * See
     * [SearchRequest.order_by][google.cloud.discoveryengine.v1beta.SearchRequest.order_by]
     * for definition and syntax.
     * The value must be a UTF-8 encoded string with a length limit of 1,000
     * characters. Otherwise, an INVALID_ARGUMENT error is returned.
     * This can only be set for `search` events. Other event types should not set
     * this field. Otherwise, an INVALID_ARGUMENT error is returned.
     *
     * Generated from protobuf field <code>string order_by = 2;</code>
     * @return string
     */
    public function getOrderBy()
    {
        return $this->order_by;
    }

    /**
     * The order in which products are returned, if applicable.
     * See
     * [SearchRequest.order_by][google.cloud.discoveryengine.v1beta.SearchRequest.order_by]
     * for definition and syntax.
     * The value must be a UTF-8 encoded string with a length limit of 1,000
     * characters. Otherwise, an INVALID_ARGUMENT error is returned.
     * This can only be set for `search` events. Other event types should not set
     * this field. Otherwise, an INVALID_ARGUMENT error is returned.
     *
     * Generated from protobuf field <code>string order_by = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setOrderBy($var)
    {
        GPBUtil::checkString($var, True);
        $this->order_by = $var;

        return $this;
    }

    /**
     * An integer that specifies the current offset for pagination (the 0-indexed
     * starting location, amongst the products deemed by the API as relevant).
     * See
     * [SearchRequest.offset][google.cloud.discoveryengine.v1beta.SearchRequest.offset]
     * for definition.
     * If this field is negative, an INVALID_ARGUMENT is returned.
     * This can only be set for `search` events. Other event types should not set
     * this field. Otherwise, an INVALID_ARGUMENT error is returned.
     *
     * Generated from protobuf field <code>optional int32 offset = 3;</code>
     * @return int
     */
    public function getOffset()
    {
        return isset($this->offset) ? $this->offset : 0;
    }

    public function hasOffset()
    {
        return isset($this->offset);
    }

    public function clearOffset()
    {
        unset($this->offset);
    }

    /**
     * An integer that specifies the current offset for pagination (the 0-indexed
     * starting location, amongst the products deemed by the API as relevant).
     * See
     * [SearchRequest.offset][google.cloud.discoveryengine.v1beta.SearchRequest.offset]
     * for definition.
     * If this field is negative, an INVALID_ARGUMENT is returned.
     * This can only be set for `search` events. Other event types should not set
     * this field. Otherwise, an INVALID_ARGUMENT error is returned.
     *
     * Generated from protobuf field <code>optional int32 offset = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setOffset($var)
    {
        GPBUtil::checkInt32($var);
        $this->offset = $var;

        return $this;
    }

}

