<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/clouddms/v1/clouddms_resources.proto

namespace Google\Cloud\CloudDms\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Specifies required connection parameters, and, optionally, the parameters
 * required to create a Cloud SQL destination database instance.
 *
 * Generated from protobuf message <code>google.cloud.clouddms.v1.CloudSqlConnectionProfile</code>
 */
class CloudSqlConnectionProfile extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. The Cloud SQL instance ID that this connection profile is associated with.
     *
     * Generated from protobuf field <code>string cloud_sql_id = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $cloud_sql_id = '';
    /**
     * Immutable. Metadata used to create the destination Cloud SQL database.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.CloudSqlSettings settings = 2 [(.google.api.field_behavior) = IMMUTABLE];</code>
     */
    private $settings = null;
    /**
     * Output only. The Cloud SQL database instance's private IP.
     *
     * Generated from protobuf field <code>string private_ip = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $private_ip = '';
    /**
     * Output only. The Cloud SQL database instance's public IP.
     *
     * Generated from protobuf field <code>string public_ip = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $public_ip = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $cloud_sql_id
     *           Output only. The Cloud SQL instance ID that this connection profile is associated with.
     *     @type \Google\Cloud\CloudDms\V1\CloudSqlSettings $settings
     *           Immutable. Metadata used to create the destination Cloud SQL database.
     *     @type string $private_ip
     *           Output only. The Cloud SQL database instance's private IP.
     *     @type string $public_ip
     *           Output only. The Cloud SQL database instance's public IP.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Clouddms\V1\ClouddmsResources::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. The Cloud SQL instance ID that this connection profile is associated with.
     *
     * Generated from protobuf field <code>string cloud_sql_id = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getCloudSqlId()
    {
        return $this->cloud_sql_id;
    }

    /**
     * Output only. The Cloud SQL instance ID that this connection profile is associated with.
     *
     * Generated from protobuf field <code>string cloud_sql_id = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setCloudSqlId($var)
    {
        GPBUtil::checkString($var, True);
        $this->cloud_sql_id = $var;

        return $this;
    }

    /**
     * Immutable. Metadata used to create the destination Cloud SQL database.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.CloudSqlSettings settings = 2 [(.google.api.field_behavior) = IMMUTABLE];</code>
     * @return \Google\Cloud\CloudDms\V1\CloudSqlSettings|null
     */
    public function getSettings()
    {
        return $this->settings;
    }

    public function hasSettings()
    {
        return isset($this->settings);
    }

    public function clearSettings()
    {
        unset($this->settings);
    }

    /**
     * Immutable. Metadata used to create the destination Cloud SQL database.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.CloudSqlSettings settings = 2 [(.google.api.field_behavior) = IMMUTABLE];</code>
     * @param \Google\Cloud\CloudDms\V1\CloudSqlSettings $var
     * @return $this
     */
    public function setSettings($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\CloudDms\V1\CloudSqlSettings::class);
        $this->settings = $var;

        return $this;
    }

    /**
     * Output only. The Cloud SQL database instance's private IP.
     *
     * Generated from protobuf field <code>string private_ip = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getPrivateIp()
    {
        return $this->private_ip;
    }

    /**
     * Output only. The Cloud SQL database instance's private IP.
     *
     * Generated from protobuf field <code>string private_ip = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setPrivateIp($var)
    {
        GPBUtil::checkString($var, True);
        $this->private_ip = $var;

        return $this;
    }

    /**
     * Output only. The Cloud SQL database instance's public IP.
     *
     * Generated from protobuf field <code>string public_ip = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getPublicIp()
    {
        return $this->public_ip;
    }

    /**
     * Output only. The Cloud SQL database instance's public IP.
     *
     * Generated from protobuf field <code>string public_ip = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setPublicIp($var)
    {
        GPBUtil::checkString($var, True);
        $this->public_ip = $var;

        return $this;
    }

}

