<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/gaming/v1/game_server_clusters.proto

namespace Google\Cloud\Gaming\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for GameServerClustersService.ListGameServerClusters.
 *
 * Generated from protobuf message <code>google.cloud.gaming.v1.ListGameServerClustersRequest</code>
 */
class ListGameServerClustersRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent resource name, in the following form:
     * "projects/{project}/locations/{location}/realms/{realm}".
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $parent = '';
    /**
     * Optional. The maximum number of items to return. If unspecified, the server
     * will pick an appropriate default. The server may return fewer items than
     * requested. A caller should only rely on response's
     * [next_page_token][google.cloud.gaming.v1.ListGameServerClustersResponse.next_page_token] to
     * determine if there are more GameServerClusters left to be queried.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $page_size = 0;
    /**
     * Optional. The next_page_token value returned from a previous List request, if any.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $page_token = '';
    /**
     * Optional. The filter to apply to list results.
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $filter = '';
    /**
     * Optional. Specifies the ordering of results following syntax at
     * https://cloud.google.com/apis/design/design_patterns#sorting_order.
     *
     * Generated from protobuf field <code>string order_by = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $order_by = '';
    /**
     * Optional. View for the returned GameServerCluster objects. When `FULL` is
     * specified, the `cluster_state` field is also returned in the
     * GameServerCluster object, which includes the state of the referenced
     * Kubernetes cluster such as versions and provider info. The default/unset
     * value is GAME_SERVER_CLUSTER_VIEW_UNSPECIFIED, same as BASIC, which does
     * not return the `cluster_state` field.
     *
     * Generated from protobuf field <code>.google.cloud.gaming.v1.GameServerClusterView view = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $view = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent resource name, in the following form:
     *           "projects/{project}/locations/{location}/realms/{realm}".
     *     @type int $page_size
     *           Optional. The maximum number of items to return. If unspecified, the server
     *           will pick an appropriate default. The server may return fewer items than
     *           requested. A caller should only rely on response's
     *           [next_page_token][google.cloud.gaming.v1.ListGameServerClustersResponse.next_page_token] to
     *           determine if there are more GameServerClusters left to be queried.
     *     @type string $page_token
     *           Optional. The next_page_token value returned from a previous List request, if any.
     *     @type string $filter
     *           Optional. The filter to apply to list results.
     *     @type string $order_by
     *           Optional. Specifies the ordering of results following syntax at
     *           https://cloud.google.com/apis/design/design_patterns#sorting_order.
     *     @type int $view
     *           Optional. View for the returned GameServerCluster objects. When `FULL` is
     *           specified, the `cluster_state` field is also returned in the
     *           GameServerCluster object, which includes the state of the referenced
     *           Kubernetes cluster such as versions and provider info. The default/unset
     *           value is GAME_SERVER_CLUSTER_VIEW_UNSPECIFIED, same as BASIC, which does
     *           not return the `cluster_state` field.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Gaming\V1\GameServerClusters::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent resource name, in the following form:
     * "projects/{project}/locations/{location}/realms/{realm}".
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent resource name, in the following form:
     * "projects/{project}/locations/{location}/realms/{realm}".
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. The maximum number of items to return. If unspecified, the server
     * will pick an appropriate default. The server may return fewer items than
     * requested. A caller should only rely on response's
     * [next_page_token][google.cloud.gaming.v1.ListGameServerClustersResponse.next_page_token] to
     * determine if there are more GameServerClusters left to be queried.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. The maximum number of items to return. If unspecified, the server
     * will pick an appropriate default. The server may return fewer items than
     * requested. A caller should only rely on response's
     * [next_page_token][google.cloud.gaming.v1.ListGameServerClustersResponse.next_page_token] to
     * determine if there are more GameServerClusters left to be queried.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. The next_page_token value returned from a previous List request, if any.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. The next_page_token value returned from a previous List request, if any.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * Optional. The filter to apply to list results.
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Optional. The filter to apply to list results.
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * Optional. Specifies the ordering of results following syntax at
     * https://cloud.google.com/apis/design/design_patterns#sorting_order.
     *
     * Generated from protobuf field <code>string order_by = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getOrderBy()
    {
        return $this->order_by;
    }

    /**
     * Optional. Specifies the ordering of results following syntax at
     * https://cloud.google.com/apis/design/design_patterns#sorting_order.
     *
     * Generated from protobuf field <code>string order_by = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setOrderBy($var)
    {
        GPBUtil::checkString($var, True);
        $this->order_by = $var;

        return $this;
    }

    /**
     * Optional. View for the returned GameServerCluster objects. When `FULL` is
     * specified, the `cluster_state` field is also returned in the
     * GameServerCluster object, which includes the state of the referenced
     * Kubernetes cluster such as versions and provider info. The default/unset
     * value is GAME_SERVER_CLUSTER_VIEW_UNSPECIFIED, same as BASIC, which does
     * not return the `cluster_state` field.
     *
     * Generated from protobuf field <code>.google.cloud.gaming.v1.GameServerClusterView view = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getView()
    {
        return $this->view;
    }

    /**
     * Optional. View for the returned GameServerCluster objects. When `FULL` is
     * specified, the `cluster_state` field is also returned in the
     * GameServerCluster object, which includes the state of the referenced
     * Kubernetes cluster such as versions and provider info. The default/unset
     * value is GAME_SERVER_CLUSTER_VIEW_UNSPECIFIED, same as BASIC, which does
     * not return the `cluster_state` field.
     *
     * Generated from protobuf field <code>.google.cloud.gaming.v1.GameServerClusterView view = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setView($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Gaming\V1\GameServerClusterView::class);
        $this->view = $var;

        return $this;
    }

}

