<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/gkemulticloud/v1/attached_service.proto

namespace Google\Cloud\GkeMultiCloud\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for `AttachedClusters.ImportAttachedCluster` method.
 *
 * Generated from protobuf message <code>google.cloud.gkemulticloud.v1.ImportAttachedClusterRequest</code>
 */
class ImportAttachedClusterRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent location where this
     * [AttachedCluster][google.cloud.gkemulticloud.v1.AttachedCluster] resource
     * will be created.
     * Location names are formatted as `projects/<project-id>/locations/<region>`.
     * See [Resource Names](https://cloud.google.com/apis/design/resource_names)
     * for more details on Google Cloud resource names.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $parent = '';
    /**
     * If set, only validate the request, but do not actually import the cluster.
     *
     * Generated from protobuf field <code>bool validate_only = 2;</code>
     */
    private $validate_only = false;
    /**
     * Required. The name of the fleet membership resource to import.
     *
     * Generated from protobuf field <code>string fleet_membership = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $fleet_membership = '';
    /**
     * Required. The platform version for the cluster (e.g. `1.19.0-gke.1000`).
     * You can list all supported versions on a given Google Cloud region by
     * calling
     * [GetAttachedServerConfig][google.cloud.gkemulticloud.v1.AttachedClusters.GetAttachedServerConfig].
     *
     * Generated from protobuf field <code>string platform_version = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $platform_version = '';
    /**
     * Required. The Kubernetes distribution of the underlying attached cluster.
     * Supported values: ["eks", "aks"].
     *
     * Generated from protobuf field <code>string distribution = 5 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $distribution = '';

    /**
     * @param string $parent          Required. The parent location where this
     *                                [AttachedCluster][google.cloud.gkemulticloud.v1.AttachedCluster] resource
     *                                will be created.
     *
     *                                Location names are formatted as `projects/<project-id>/locations/<region>`.
     *
     *                                See [Resource Names](https://cloud.google.com/apis/design/resource_names)
     *                                for more details on Google Cloud resource names. Please see
     *                                {@see AttachedClustersClient::locationName()} for help formatting this field.
     * @param string $fleetMembership Required. The name of the fleet membership resource to import.
     *
     * @return \Google\Cloud\GkeMultiCloud\V1\ImportAttachedClusterRequest
     *
     * @experimental
     */
    public static function build(string $parent, string $fleetMembership): self
    {
        return (new self())
            ->setParent($parent)
            ->setFleetMembership($fleetMembership);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent location where this
     *           [AttachedCluster][google.cloud.gkemulticloud.v1.AttachedCluster] resource
     *           will be created.
     *           Location names are formatted as `projects/<project-id>/locations/<region>`.
     *           See [Resource Names](https://cloud.google.com/apis/design/resource_names)
     *           for more details on Google Cloud resource names.
     *     @type bool $validate_only
     *           If set, only validate the request, but do not actually import the cluster.
     *     @type string $fleet_membership
     *           Required. The name of the fleet membership resource to import.
     *     @type string $platform_version
     *           Required. The platform version for the cluster (e.g. `1.19.0-gke.1000`).
     *           You can list all supported versions on a given Google Cloud region by
     *           calling
     *           [GetAttachedServerConfig][google.cloud.gkemulticloud.v1.AttachedClusters.GetAttachedServerConfig].
     *     @type string $distribution
     *           Required. The Kubernetes distribution of the underlying attached cluster.
     *           Supported values: ["eks", "aks"].
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Gkemulticloud\V1\AttachedService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent location where this
     * [AttachedCluster][google.cloud.gkemulticloud.v1.AttachedCluster] resource
     * will be created.
     * Location names are formatted as `projects/<project-id>/locations/<region>`.
     * See [Resource Names](https://cloud.google.com/apis/design/resource_names)
     * for more details on Google Cloud resource names.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent location where this
     * [AttachedCluster][google.cloud.gkemulticloud.v1.AttachedCluster] resource
     * will be created.
     * Location names are formatted as `projects/<project-id>/locations/<region>`.
     * See [Resource Names](https://cloud.google.com/apis/design/resource_names)
     * for more details on Google Cloud resource names.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * If set, only validate the request, but do not actually import the cluster.
     *
     * Generated from protobuf field <code>bool validate_only = 2;</code>
     * @return bool
     */
    public function getValidateOnly()
    {
        return $this->validate_only;
    }

    /**
     * If set, only validate the request, but do not actually import the cluster.
     *
     * Generated from protobuf field <code>bool validate_only = 2;</code>
     * @param bool $var
     * @return $this
     */
    public function setValidateOnly($var)
    {
        GPBUtil::checkBool($var);
        $this->validate_only = $var;

        return $this;
    }

    /**
     * Required. The name of the fleet membership resource to import.
     *
     * Generated from protobuf field <code>string fleet_membership = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getFleetMembership()
    {
        return $this->fleet_membership;
    }

    /**
     * Required. The name of the fleet membership resource to import.
     *
     * Generated from protobuf field <code>string fleet_membership = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setFleetMembership($var)
    {
        GPBUtil::checkString($var, True);
        $this->fleet_membership = $var;

        return $this;
    }

    /**
     * Required. The platform version for the cluster (e.g. `1.19.0-gke.1000`).
     * You can list all supported versions on a given Google Cloud region by
     * calling
     * [GetAttachedServerConfig][google.cloud.gkemulticloud.v1.AttachedClusters.GetAttachedServerConfig].
     *
     * Generated from protobuf field <code>string platform_version = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getPlatformVersion()
    {
        return $this->platform_version;
    }

    /**
     * Required. The platform version for the cluster (e.g. `1.19.0-gke.1000`).
     * You can list all supported versions on a given Google Cloud region by
     * calling
     * [GetAttachedServerConfig][google.cloud.gkemulticloud.v1.AttachedClusters.GetAttachedServerConfig].
     *
     * Generated from protobuf field <code>string platform_version = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setPlatformVersion($var)
    {
        GPBUtil::checkString($var, True);
        $this->platform_version = $var;

        return $this;
    }

    /**
     * Required. The Kubernetes distribution of the underlying attached cluster.
     * Supported values: ["eks", "aks"].
     *
     * Generated from protobuf field <code>string distribution = 5 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getDistribution()
    {
        return $this->distribution;
    }

    /**
     * Required. The Kubernetes distribution of the underlying attached cluster.
     * Supported values: ["eks", "aks"].
     *
     * Generated from protobuf field <code>string distribution = 5 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setDistribution($var)
    {
        GPBUtil::checkString($var, True);
        $this->distribution = $var;

        return $this;
    }

}

