<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/orchestration/airflow/service/v1/environments.proto

namespace Google\Cloud\Orchestration\Airflow\Service\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Message containing information about the result of an upgrade check
 * operation.
 *
 * Generated from protobuf message <code>google.cloud.orchestration.airflow.service.v1.CheckUpgradeResponse</code>
 */
class CheckUpgradeResponse extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. Url for a docker build log of an upgraded image.
     *
     * Generated from protobuf field <code>string build_log_uri = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $build_log_uri = '';
    /**
     * Output only. Whether build has succeeded or failed on modules conflicts.
     *
     * Generated from protobuf field <code>.google.cloud.orchestration.airflow.service.v1.CheckUpgradeResponse.ConflictResult contains_pypi_modules_conflict = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $contains_pypi_modules_conflict = 0;
    /**
     * Output only. Extract from a docker image build log containing information
     * about pypi modules conflicts.
     *
     * Generated from protobuf field <code>string pypi_conflict_build_log_extract = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $pypi_conflict_build_log_extract = '';
    /**
     * Composer image for which the build was happening.
     *
     * Generated from protobuf field <code>string image_version = 5;</code>
     */
    private $image_version = '';
    /**
     * Pypi dependencies specified in the environment configuration, at the time
     * when the build was triggered.
     *
     * Generated from protobuf field <code>map<string, string> pypi_dependencies = 6;</code>
     */
    private $pypi_dependencies;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $build_log_uri
     *           Output only. Url for a docker build log of an upgraded image.
     *     @type int $contains_pypi_modules_conflict
     *           Output only. Whether build has succeeded or failed on modules conflicts.
     *     @type string $pypi_conflict_build_log_extract
     *           Output only. Extract from a docker image build log containing information
     *           about pypi modules conflicts.
     *     @type string $image_version
     *           Composer image for which the build was happening.
     *     @type array|\Google\Protobuf\Internal\MapField $pypi_dependencies
     *           Pypi dependencies specified in the environment configuration, at the time
     *           when the build was triggered.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Orchestration\Airflow\Service\V1\Environments::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. Url for a docker build log of an upgraded image.
     *
     * Generated from protobuf field <code>string build_log_uri = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getBuildLogUri()
    {
        return $this->build_log_uri;
    }

    /**
     * Output only. Url for a docker build log of an upgraded image.
     *
     * Generated from protobuf field <code>string build_log_uri = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setBuildLogUri($var)
    {
        GPBUtil::checkString($var, True);
        $this->build_log_uri = $var;

        return $this;
    }

    /**
     * Output only. Whether build has succeeded or failed on modules conflicts.
     *
     * Generated from protobuf field <code>.google.cloud.orchestration.airflow.service.v1.CheckUpgradeResponse.ConflictResult contains_pypi_modules_conflict = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getContainsPypiModulesConflict()
    {
        return $this->contains_pypi_modules_conflict;
    }

    /**
     * Output only. Whether build has succeeded or failed on modules conflicts.
     *
     * Generated from protobuf field <code>.google.cloud.orchestration.airflow.service.v1.CheckUpgradeResponse.ConflictResult contains_pypi_modules_conflict = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setContainsPypiModulesConflict($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Orchestration\Airflow\Service\V1\CheckUpgradeResponse\ConflictResult::class);
        $this->contains_pypi_modules_conflict = $var;

        return $this;
    }

    /**
     * Output only. Extract from a docker image build log containing information
     * about pypi modules conflicts.
     *
     * Generated from protobuf field <code>string pypi_conflict_build_log_extract = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getPypiConflictBuildLogExtract()
    {
        return $this->pypi_conflict_build_log_extract;
    }

    /**
     * Output only. Extract from a docker image build log containing information
     * about pypi modules conflicts.
     *
     * Generated from protobuf field <code>string pypi_conflict_build_log_extract = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setPypiConflictBuildLogExtract($var)
    {
        GPBUtil::checkString($var, True);
        $this->pypi_conflict_build_log_extract = $var;

        return $this;
    }

    /**
     * Composer image for which the build was happening.
     *
     * Generated from protobuf field <code>string image_version = 5;</code>
     * @return string
     */
    public function getImageVersion()
    {
        return $this->image_version;
    }

    /**
     * Composer image for which the build was happening.
     *
     * Generated from protobuf field <code>string image_version = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setImageVersion($var)
    {
        GPBUtil::checkString($var, True);
        $this->image_version = $var;

        return $this;
    }

    /**
     * Pypi dependencies specified in the environment configuration, at the time
     * when the build was triggered.
     *
     * Generated from protobuf field <code>map<string, string> pypi_dependencies = 6;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getPypiDependencies()
    {
        return $this->pypi_dependencies;
    }

    /**
     * Pypi dependencies specified in the environment configuration, at the time
     * when the build was triggered.
     *
     * Generated from protobuf field <code>map<string, string> pypi_dependencies = 6;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setPypiDependencies($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->pypi_dependencies = $arr;

        return $this;
    }

}

