<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/securitycenter/v1/bigquery_export.proto

namespace Google\Cloud\SecurityCenter\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Configures how to deliver Findings to BigQuery Instance.
 *
 * Generated from protobuf message <code>google.cloud.securitycenter.v1.BigQueryExport</code>
 */
class BigQueryExport extends \Google\Protobuf\Internal\Message
{
    /**
     * The relative resource name of this export. See:
     * https://cloud.google.com/apis/design/resource_names#relative_resource_name.
     * Example format:
     * "organizations/{organization_id}/bigQueryExports/{export_id}" Example
     * format: "folders/{folder_id}/bigQueryExports/{export_id}" Example format:
     * "projects/{project_id}/bigQueryExports/{export_id}"
     * This field is provided in responses, and is ignored when provided in create
     * requests.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     */
    private $name = '';
    /**
     * The description of the export (max of 1024 characters).
     *
     * Generated from protobuf field <code>string description = 2;</code>
     */
    private $description = '';
    /**
     * Expression that defines the filter to apply across create/update events
     * of findings. The expression is a list of zero or more restrictions combined
     * via logical operators `AND` and `OR`. Parentheses are supported, and `OR`
     * has higher precedence than `AND`.
     * Restrictions have the form `<field> <operator> <value>` and may have a
     * `-` character in front of them to indicate negation. The fields map to
     * those defined in the corresponding resource.
     * The supported operators are:
     * * `=` for all value types.
     * * `>`, `<`, `>=`, `<=` for integer values.
     * * `:`, meaning substring matching, for strings.
     * The supported value types are:
     * * string literals in quotes.
     * * integer literals without quotes.
     * * boolean literals `true` and `false` without quotes.
     *
     * Generated from protobuf field <code>string filter = 3;</code>
     */
    private $filter = '';
    /**
     * The dataset to write findings' updates to. Its format is
     * "projects/[project_id]/datasets/[bigquery_dataset_id]".
     * BigQuery Dataset unique ID  must contain only letters (a-z, A-Z), numbers
     * (0-9), or underscores (_).
     *
     * Generated from protobuf field <code>string dataset = 4;</code>
     */
    private $dataset = '';
    /**
     * Output only. The time at which the BigQuery export was created.
     * This field is set by the server and will be ignored if provided on export
     * on creation.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $create_time = null;
    /**
     * Output only. The most recent time at which the BigQuery export was updated.
     * This field is set by the server and will be ignored if provided on export
     * creation or update.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $update_time = null;
    /**
     * Output only. Email address of the user who last edited the BigQuery export.
     * This field is set by the server and will be ignored if provided on export
     * creation or update.
     *
     * Generated from protobuf field <code>string most_recent_editor = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $most_recent_editor = '';
    /**
     * Output only. The service account that needs permission to create table and
     * upload data to the BigQuery dataset.
     *
     * Generated from protobuf field <code>string principal = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $principal = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           The relative resource name of this export. See:
     *           https://cloud.google.com/apis/design/resource_names#relative_resource_name.
     *           Example format:
     *           "organizations/{organization_id}/bigQueryExports/{export_id}" Example
     *           format: "folders/{folder_id}/bigQueryExports/{export_id}" Example format:
     *           "projects/{project_id}/bigQueryExports/{export_id}"
     *           This field is provided in responses, and is ignored when provided in create
     *           requests.
     *     @type string $description
     *           The description of the export (max of 1024 characters).
     *     @type string $filter
     *           Expression that defines the filter to apply across create/update events
     *           of findings. The expression is a list of zero or more restrictions combined
     *           via logical operators `AND` and `OR`. Parentheses are supported, and `OR`
     *           has higher precedence than `AND`.
     *           Restrictions have the form `<field> <operator> <value>` and may have a
     *           `-` character in front of them to indicate negation. The fields map to
     *           those defined in the corresponding resource.
     *           The supported operators are:
     *           * `=` for all value types.
     *           * `>`, `<`, `>=`, `<=` for integer values.
     *           * `:`, meaning substring matching, for strings.
     *           The supported value types are:
     *           * string literals in quotes.
     *           * integer literals without quotes.
     *           * boolean literals `true` and `false` without quotes.
     *     @type string $dataset
     *           The dataset to write findings' updates to. Its format is
     *           "projects/[project_id]/datasets/[bigquery_dataset_id]".
     *           BigQuery Dataset unique ID  must contain only letters (a-z, A-Z), numbers
     *           (0-9), or underscores (_).
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. The time at which the BigQuery export was created.
     *           This field is set by the server and will be ignored if provided on export
     *           on creation.
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Output only. The most recent time at which the BigQuery export was updated.
     *           This field is set by the server and will be ignored if provided on export
     *           creation or update.
     *     @type string $most_recent_editor
     *           Output only. Email address of the user who last edited the BigQuery export.
     *           This field is set by the server and will be ignored if provided on export
     *           creation or update.
     *     @type string $principal
     *           Output only. The service account that needs permission to create table and
     *           upload data to the BigQuery dataset.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Securitycenter\V1\BigqueryExport::initOnce();
        parent::__construct($data);
    }

    /**
     * The relative resource name of this export. See:
     * https://cloud.google.com/apis/design/resource_names#relative_resource_name.
     * Example format:
     * "organizations/{organization_id}/bigQueryExports/{export_id}" Example
     * format: "folders/{folder_id}/bigQueryExports/{export_id}" Example format:
     * "projects/{project_id}/bigQueryExports/{export_id}"
     * This field is provided in responses, and is ignored when provided in create
     * requests.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * The relative resource name of this export. See:
     * https://cloud.google.com/apis/design/resource_names#relative_resource_name.
     * Example format:
     * "organizations/{organization_id}/bigQueryExports/{export_id}" Example
     * format: "folders/{folder_id}/bigQueryExports/{export_id}" Example format:
     * "projects/{project_id}/bigQueryExports/{export_id}"
     * This field is provided in responses, and is ignored when provided in create
     * requests.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * The description of the export (max of 1024 characters).
     *
     * Generated from protobuf field <code>string description = 2;</code>
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * The description of the export (max of 1024 characters).
     *
     * Generated from protobuf field <code>string description = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->description = $var;

        return $this;
    }

    /**
     * Expression that defines the filter to apply across create/update events
     * of findings. The expression is a list of zero or more restrictions combined
     * via logical operators `AND` and `OR`. Parentheses are supported, and `OR`
     * has higher precedence than `AND`.
     * Restrictions have the form `<field> <operator> <value>` and may have a
     * `-` character in front of them to indicate negation. The fields map to
     * those defined in the corresponding resource.
     * The supported operators are:
     * * `=` for all value types.
     * * `>`, `<`, `>=`, `<=` for integer values.
     * * `:`, meaning substring matching, for strings.
     * The supported value types are:
     * * string literals in quotes.
     * * integer literals without quotes.
     * * boolean literals `true` and `false` without quotes.
     *
     * Generated from protobuf field <code>string filter = 3;</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Expression that defines the filter to apply across create/update events
     * of findings. The expression is a list of zero or more restrictions combined
     * via logical operators `AND` and `OR`. Parentheses are supported, and `OR`
     * has higher precedence than `AND`.
     * Restrictions have the form `<field> <operator> <value>` and may have a
     * `-` character in front of them to indicate negation. The fields map to
     * those defined in the corresponding resource.
     * The supported operators are:
     * * `=` for all value types.
     * * `>`, `<`, `>=`, `<=` for integer values.
     * * `:`, meaning substring matching, for strings.
     * The supported value types are:
     * * string literals in quotes.
     * * integer literals without quotes.
     * * boolean literals `true` and `false` without quotes.
     *
     * Generated from protobuf field <code>string filter = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * The dataset to write findings' updates to. Its format is
     * "projects/[project_id]/datasets/[bigquery_dataset_id]".
     * BigQuery Dataset unique ID  must contain only letters (a-z, A-Z), numbers
     * (0-9), or underscores (_).
     *
     * Generated from protobuf field <code>string dataset = 4;</code>
     * @return string
     */
    public function getDataset()
    {
        return $this->dataset;
    }

    /**
     * The dataset to write findings' updates to. Its format is
     * "projects/[project_id]/datasets/[bigquery_dataset_id]".
     * BigQuery Dataset unique ID  must contain only letters (a-z, A-Z), numbers
     * (0-9), or underscores (_).
     *
     * Generated from protobuf field <code>string dataset = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setDataset($var)
    {
        GPBUtil::checkString($var, True);
        $this->dataset = $var;

        return $this;
    }

    /**
     * Output only. The time at which the BigQuery export was created.
     * This field is set by the server and will be ignored if provided on export
     * on creation.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. The time at which the BigQuery export was created.
     * This field is set by the server and will be ignored if provided on export
     * on creation.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Output only. The most recent time at which the BigQuery export was updated.
     * This field is set by the server and will be ignored if provided on export
     * creation or update.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Output only. The most recent time at which the BigQuery export was updated.
     * This field is set by the server and will be ignored if provided on export
     * creation or update.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * Output only. Email address of the user who last edited the BigQuery export.
     * This field is set by the server and will be ignored if provided on export
     * creation or update.
     *
     * Generated from protobuf field <code>string most_recent_editor = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getMostRecentEditor()
    {
        return $this->most_recent_editor;
    }

    /**
     * Output only. Email address of the user who last edited the BigQuery export.
     * This field is set by the server and will be ignored if provided on export
     * creation or update.
     *
     * Generated from protobuf field <code>string most_recent_editor = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setMostRecentEditor($var)
    {
        GPBUtil::checkString($var, True);
        $this->most_recent_editor = $var;

        return $this;
    }

    /**
     * Output only. The service account that needs permission to create table and
     * upload data to the BigQuery dataset.
     *
     * Generated from protobuf field <code>string principal = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getPrincipal()
    {
        return $this->principal;
    }

    /**
     * Output only. The service account that needs permission to create table and
     * upload data to the BigQuery dataset.
     *
     * Generated from protobuf field <code>string principal = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setPrincipal($var)
    {
        GPBUtil::checkString($var, True);
        $this->principal = $var;

        return $this;
    }

}

