<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/securitycenter/v1/cloud_dlp_inspection.proto

namespace Google\Cloud\SecurityCenter\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Details about the Cloud Data Loss Prevention (Cloud DLP) [inspection
 * job](https://cloud.google.com/dlp/docs/concepts-job-triggers) that produced
 * the finding.
 *
 * Generated from protobuf message <code>google.cloud.securitycenter.v1.CloudDlpInspection</code>
 */
class CloudDlpInspection extends \Google\Protobuf\Internal\Message
{
    /**
     * Name of the inspection job, for example,
     * `projects/123/locations/europe/dlpJobs/i-8383929`.
     *
     * Generated from protobuf field <code>string inspect_job = 1 [(.google.api.resource_reference) = {</code>
     */
    private $inspect_job = '';
    /**
     * The [type of
     * information](https://cloud.google.com/dlp/docs/infotypes-reference) found,
     * for example, `EMAIL_ADDRESS` or `STREET_ADDRESS`.
     *
     * Generated from protobuf field <code>string info_type = 2;</code>
     */
    private $info_type = '';
    /**
     * The number of times Cloud DLP found this infoType within this job
     * and resource.
     *
     * Generated from protobuf field <code>int64 info_type_count = 3;</code>
     */
    private $info_type_count = 0;
    /**
     * Whether Cloud DLP scanned the complete resource or a sampled subset.
     *
     * Generated from protobuf field <code>bool full_scan = 4;</code>
     */
    private $full_scan = false;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $inspect_job
     *           Name of the inspection job, for example,
     *           `projects/123/locations/europe/dlpJobs/i-8383929`.
     *     @type string $info_type
     *           The [type of
     *           information](https://cloud.google.com/dlp/docs/infotypes-reference) found,
     *           for example, `EMAIL_ADDRESS` or `STREET_ADDRESS`.
     *     @type int|string $info_type_count
     *           The number of times Cloud DLP found this infoType within this job
     *           and resource.
     *     @type bool $full_scan
     *           Whether Cloud DLP scanned the complete resource or a sampled subset.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Securitycenter\V1\CloudDlpInspection::initOnce();
        parent::__construct($data);
    }

    /**
     * Name of the inspection job, for example,
     * `projects/123/locations/europe/dlpJobs/i-8383929`.
     *
     * Generated from protobuf field <code>string inspect_job = 1 [(.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getInspectJob()
    {
        return $this->inspect_job;
    }

    /**
     * Name of the inspection job, for example,
     * `projects/123/locations/europe/dlpJobs/i-8383929`.
     *
     * Generated from protobuf field <code>string inspect_job = 1 [(.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setInspectJob($var)
    {
        GPBUtil::checkString($var, True);
        $this->inspect_job = $var;

        return $this;
    }

    /**
     * The [type of
     * information](https://cloud.google.com/dlp/docs/infotypes-reference) found,
     * for example, `EMAIL_ADDRESS` or `STREET_ADDRESS`.
     *
     * Generated from protobuf field <code>string info_type = 2;</code>
     * @return string
     */
    public function getInfoType()
    {
        return $this->info_type;
    }

    /**
     * The [type of
     * information](https://cloud.google.com/dlp/docs/infotypes-reference) found,
     * for example, `EMAIL_ADDRESS` or `STREET_ADDRESS`.
     *
     * Generated from protobuf field <code>string info_type = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setInfoType($var)
    {
        GPBUtil::checkString($var, True);
        $this->info_type = $var;

        return $this;
    }

    /**
     * The number of times Cloud DLP found this infoType within this job
     * and resource.
     *
     * Generated from protobuf field <code>int64 info_type_count = 3;</code>
     * @return int|string
     */
    public function getInfoTypeCount()
    {
        return $this->info_type_count;
    }

    /**
     * The number of times Cloud DLP found this infoType within this job
     * and resource.
     *
     * Generated from protobuf field <code>int64 info_type_count = 3;</code>
     * @param int|string $var
     * @return $this
     */
    public function setInfoTypeCount($var)
    {
        GPBUtil::checkInt64($var);
        $this->info_type_count = $var;

        return $this;
    }

    /**
     * Whether Cloud DLP scanned the complete resource or a sampled subset.
     *
     * Generated from protobuf field <code>bool full_scan = 4;</code>
     * @return bool
     */
    public function getFullScan()
    {
        return $this->full_scan;
    }

    /**
     * Whether Cloud DLP scanned the complete resource or a sampled subset.
     *
     * Generated from protobuf field <code>bool full_scan = 4;</code>
     * @param bool $var
     * @return $this
     */
    public function setFullScan($var)
    {
        GPBUtil::checkBool($var);
        $this->full_scan = $var;

        return $this;
    }

}

