<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/sql/v1beta4/cloud_sql.proto

namespace Google\Cloud\Sql\V1beta4;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Generated from protobuf message <code>google.cloud.sql.v1beta4.SqlInstancesVerifyExternalSyncSettingsRequest</code>
 */
class SqlInstancesVerifyExternalSyncSettingsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Cloud SQL instance ID. This does not include the project ID.
     *
     * Generated from protobuf field <code>string instance = 1;</code>
     */
    private $instance = '';
    /**
     * Project ID of the project that contains the instance.
     *
     * Generated from protobuf field <code>string project = 2;</code>
     */
    private $project = '';
    /**
     * Flag to enable verifying connection only
     *
     * Generated from protobuf field <code>bool verify_connection_only = 3;</code>
     */
    private $verify_connection_only = false;
    /**
     * External sync mode
     *
     * Generated from protobuf field <code>.google.cloud.sql.v1beta4.SqlInstancesVerifyExternalSyncSettingsRequest.ExternalSyncMode sync_mode = 4;</code>
     */
    private $sync_mode = 0;
    /**
     * Optional. Flag to verify settings required by replication setup only
     *
     * Generated from protobuf field <code>bool verify_replication_only = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $verify_replication_only = false;
    protected $sync_config;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $instance
     *           Cloud SQL instance ID. This does not include the project ID.
     *     @type string $project
     *           Project ID of the project that contains the instance.
     *     @type bool $verify_connection_only
     *           Flag to enable verifying connection only
     *     @type int $sync_mode
     *           External sync mode
     *     @type bool $verify_replication_only
     *           Optional. Flag to verify settings required by replication setup only
     *     @type \Google\Cloud\Sql\V1beta4\MySqlSyncConfig $mysql_sync_config
     *           Optional. MySQL-specific settings for start external sync.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Sql\V1Beta4\CloudSql::initOnce();
        parent::__construct($data);
    }

    /**
     * Cloud SQL instance ID. This does not include the project ID.
     *
     * Generated from protobuf field <code>string instance = 1;</code>
     * @return string
     */
    public function getInstance()
    {
        return $this->instance;
    }

    /**
     * Cloud SQL instance ID. This does not include the project ID.
     *
     * Generated from protobuf field <code>string instance = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setInstance($var)
    {
        GPBUtil::checkString($var, True);
        $this->instance = $var;

        return $this;
    }

    /**
     * Project ID of the project that contains the instance.
     *
     * Generated from protobuf field <code>string project = 2;</code>
     * @return string
     */
    public function getProject()
    {
        return $this->project;
    }

    /**
     * Project ID of the project that contains the instance.
     *
     * Generated from protobuf field <code>string project = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setProject($var)
    {
        GPBUtil::checkString($var, True);
        $this->project = $var;

        return $this;
    }

    /**
     * Flag to enable verifying connection only
     *
     * Generated from protobuf field <code>bool verify_connection_only = 3;</code>
     * @return bool
     */
    public function getVerifyConnectionOnly()
    {
        return $this->verify_connection_only;
    }

    /**
     * Flag to enable verifying connection only
     *
     * Generated from protobuf field <code>bool verify_connection_only = 3;</code>
     * @param bool $var
     * @return $this
     */
    public function setVerifyConnectionOnly($var)
    {
        GPBUtil::checkBool($var);
        $this->verify_connection_only = $var;

        return $this;
    }

    /**
     * External sync mode
     *
     * Generated from protobuf field <code>.google.cloud.sql.v1beta4.SqlInstancesVerifyExternalSyncSettingsRequest.ExternalSyncMode sync_mode = 4;</code>
     * @return int
     */
    public function getSyncMode()
    {
        return $this->sync_mode;
    }

    /**
     * External sync mode
     *
     * Generated from protobuf field <code>.google.cloud.sql.v1beta4.SqlInstancesVerifyExternalSyncSettingsRequest.ExternalSyncMode sync_mode = 4;</code>
     * @param int $var
     * @return $this
     */
    public function setSyncMode($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Sql\V1beta4\SqlInstancesVerifyExternalSyncSettingsRequest\ExternalSyncMode::class);
        $this->sync_mode = $var;

        return $this;
    }

    /**
     * Optional. Flag to verify settings required by replication setup only
     *
     * Generated from protobuf field <code>bool verify_replication_only = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getVerifyReplicationOnly()
    {
        return $this->verify_replication_only;
    }

    /**
     * Optional. Flag to verify settings required by replication setup only
     *
     * Generated from protobuf field <code>bool verify_replication_only = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setVerifyReplicationOnly($var)
    {
        GPBUtil::checkBool($var);
        $this->verify_replication_only = $var;

        return $this;
    }

    /**
     * Optional. MySQL-specific settings for start external sync.
     *
     * Generated from protobuf field <code>.google.cloud.sql.v1beta4.MySqlSyncConfig mysql_sync_config = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\Sql\V1beta4\MySqlSyncConfig|null
     */
    public function getMysqlSyncConfig()
    {
        return $this->readOneof(6);
    }

    public function hasMysqlSyncConfig()
    {
        return $this->hasOneof(6);
    }

    /**
     * Optional. MySQL-specific settings for start external sync.
     *
     * Generated from protobuf field <code>.google.cloud.sql.v1beta4.MySqlSyncConfig mysql_sync_config = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\Sql\V1beta4\MySqlSyncConfig $var
     * @return $this
     */
    public function setMysqlSyncConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Sql\V1beta4\MySqlSyncConfig::class);
        $this->writeOneof(6, $var);

        return $this;
    }

    /**
     * @return string
     */
    public function getSyncConfig()
    {
        return $this->whichOneof("sync_config");
    }

}

