<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/storageinsights/v1/storageinsights.proto

namespace Google\Cloud\StorageInsights\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Message describing ReportDetail object. ReportDetail represents metadata of
 * generated reports for a ReportConfig.
 * Next ID: 10
 *
 * Generated from protobuf message <code>google.cloud.storageinsights.v1.ReportDetail</code>
 */
class ReportDetail extends \Google\Protobuf\Internal\Message
{
    /**
     * Name of resource. It will be of form
     * projects/<project>/locations/<location>/reportConfigs/<report-config-id>/reportDetails/<report-detail-id>.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     */
    protected $name = '';
    /**
     * The snapshot time.
     * All the report data is referenced at this point of time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp snapshot_time = 2;</code>
     */
    protected $snapshot_time = null;
    /**
     * Prefix of the object name of each report's shard. This will have full
     * prefix except the "extension" and "shard_id".
     * For example, if the `destination_path` is
     * `{{report-config-id}}/dt={{datetime}}`, the shard object name would be
     * `gs://my-insights/1A34-F2E456-12B456-1C3D/dt=2022-05-20T06:35/1A34-F2E456-12B456-1C3D_2022-05-20T06:35_5.csv`
     * and the value of `report_path_prefix` field would be
     * `gs://my-insights/1A34-F2E456-12B456-1C3D/dt=2022-05-20T06:35/1A34-F2E456-12B456-1C3D_2022-05-20T06:35_`.
     *
     * Generated from protobuf field <code>string report_path_prefix = 8;</code>
     */
    protected $report_path_prefix = '';
    /**
     * Total shards generated for the report.
     *
     * Generated from protobuf field <code>int64 shards_count = 9;</code>
     */
    protected $shards_count = 0;
    /**
     * Status of the ReportDetail.
     *
     * Generated from protobuf field <code>.google.rpc.Status status = 4;</code>
     */
    protected $status = null;
    /**
     * Labels as key value pairs
     *
     * Generated from protobuf field <code>map<string, string> labels = 5;</code>
     */
    private $labels;
    /**
     * The date for which report is generated. The time part of target_datetime
     * will be zero till we support multiple reports per day.
     *
     * Generated from protobuf field <code>.google.type.DateTime target_datetime = 6;</code>
     */
    protected $target_datetime = null;
    /**
     * Metrics of the report.
     *
     * Generated from protobuf field <code>.google.cloud.storageinsights.v1.ReportDetail.Metrics report_metrics = 7;</code>
     */
    protected $report_metrics = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Name of resource. It will be of form
     *           projects/<project>/locations/<location>/reportConfigs/<report-config-id>/reportDetails/<report-detail-id>.
     *     @type \Google\Protobuf\Timestamp $snapshot_time
     *           The snapshot time.
     *           All the report data is referenced at this point of time.
     *     @type string $report_path_prefix
     *           Prefix of the object name of each report's shard. This will have full
     *           prefix except the "extension" and "shard_id".
     *           For example, if the `destination_path` is
     *           `{{report-config-id}}/dt={{datetime}}`, the shard object name would be
     *           `gs://my-insights/1A34-F2E456-12B456-1C3D/dt=2022-05-20T06:35/1A34-F2E456-12B456-1C3D_2022-05-20T06:35_5.csv`
     *           and the value of `report_path_prefix` field would be
     *           `gs://my-insights/1A34-F2E456-12B456-1C3D/dt=2022-05-20T06:35/1A34-F2E456-12B456-1C3D_2022-05-20T06:35_`.
     *     @type int|string $shards_count
     *           Total shards generated for the report.
     *     @type \Google\Rpc\Status $status
     *           Status of the ReportDetail.
     *     @type array|\Google\Protobuf\Internal\MapField $labels
     *           Labels as key value pairs
     *     @type \Google\Type\DateTime $target_datetime
     *           The date for which report is generated. The time part of target_datetime
     *           will be zero till we support multiple reports per day.
     *     @type \Google\Cloud\StorageInsights\V1\ReportDetail\Metrics $report_metrics
     *           Metrics of the report.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Storageinsights\V1\Storageinsights::initOnce();
        parent::__construct($data);
    }

    /**
     * Name of resource. It will be of form
     * projects/<project>/locations/<location>/reportConfigs/<report-config-id>/reportDetails/<report-detail-id>.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Name of resource. It will be of form
     * projects/<project>/locations/<location>/reportConfigs/<report-config-id>/reportDetails/<report-detail-id>.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * The snapshot time.
     * All the report data is referenced at this point of time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp snapshot_time = 2;</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getSnapshotTime()
    {
        return $this->snapshot_time;
    }

    public function hasSnapshotTime()
    {
        return isset($this->snapshot_time);
    }

    public function clearSnapshotTime()
    {
        unset($this->snapshot_time);
    }

    /**
     * The snapshot time.
     * All the report data is referenced at this point of time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp snapshot_time = 2;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setSnapshotTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->snapshot_time = $var;

        return $this;
    }

    /**
     * Prefix of the object name of each report's shard. This will have full
     * prefix except the "extension" and "shard_id".
     * For example, if the `destination_path` is
     * `{{report-config-id}}/dt={{datetime}}`, the shard object name would be
     * `gs://my-insights/1A34-F2E456-12B456-1C3D/dt=2022-05-20T06:35/1A34-F2E456-12B456-1C3D_2022-05-20T06:35_5.csv`
     * and the value of `report_path_prefix` field would be
     * `gs://my-insights/1A34-F2E456-12B456-1C3D/dt=2022-05-20T06:35/1A34-F2E456-12B456-1C3D_2022-05-20T06:35_`.
     *
     * Generated from protobuf field <code>string report_path_prefix = 8;</code>
     * @return string
     */
    public function getReportPathPrefix()
    {
        return $this->report_path_prefix;
    }

    /**
     * Prefix of the object name of each report's shard. This will have full
     * prefix except the "extension" and "shard_id".
     * For example, if the `destination_path` is
     * `{{report-config-id}}/dt={{datetime}}`, the shard object name would be
     * `gs://my-insights/1A34-F2E456-12B456-1C3D/dt=2022-05-20T06:35/1A34-F2E456-12B456-1C3D_2022-05-20T06:35_5.csv`
     * and the value of `report_path_prefix` field would be
     * `gs://my-insights/1A34-F2E456-12B456-1C3D/dt=2022-05-20T06:35/1A34-F2E456-12B456-1C3D_2022-05-20T06:35_`.
     *
     * Generated from protobuf field <code>string report_path_prefix = 8;</code>
     * @param string $var
     * @return $this
     */
    public function setReportPathPrefix($var)
    {
        GPBUtil::checkString($var, True);
        $this->report_path_prefix = $var;

        return $this;
    }

    /**
     * Total shards generated for the report.
     *
     * Generated from protobuf field <code>int64 shards_count = 9;</code>
     * @return int|string
     */
    public function getShardsCount()
    {
        return $this->shards_count;
    }

    /**
     * Total shards generated for the report.
     *
     * Generated from protobuf field <code>int64 shards_count = 9;</code>
     * @param int|string $var
     * @return $this
     */
    public function setShardsCount($var)
    {
        GPBUtil::checkInt64($var);
        $this->shards_count = $var;

        return $this;
    }

    /**
     * Status of the ReportDetail.
     *
     * Generated from protobuf field <code>.google.rpc.Status status = 4;</code>
     * @return \Google\Rpc\Status|null
     */
    public function getStatus()
    {
        return $this->status;
    }

    public function hasStatus()
    {
        return isset($this->status);
    }

    public function clearStatus()
    {
        unset($this->status);
    }

    /**
     * Status of the ReportDetail.
     *
     * Generated from protobuf field <code>.google.rpc.Status status = 4;</code>
     * @param \Google\Rpc\Status $var
     * @return $this
     */
    public function setStatus($var)
    {
        GPBUtil::checkMessage($var, \Google\Rpc\Status::class);
        $this->status = $var;

        return $this;
    }

    /**
     * Labels as key value pairs
     *
     * Generated from protobuf field <code>map<string, string> labels = 5;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getLabels()
    {
        return $this->labels;
    }

    /**
     * Labels as key value pairs
     *
     * Generated from protobuf field <code>map<string, string> labels = 5;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setLabels($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->labels = $arr;

        return $this;
    }

    /**
     * The date for which report is generated. The time part of target_datetime
     * will be zero till we support multiple reports per day.
     *
     * Generated from protobuf field <code>.google.type.DateTime target_datetime = 6;</code>
     * @return \Google\Type\DateTime|null
     */
    public function getTargetDatetime()
    {
        return $this->target_datetime;
    }

    public function hasTargetDatetime()
    {
        return isset($this->target_datetime);
    }

    public function clearTargetDatetime()
    {
        unset($this->target_datetime);
    }

    /**
     * The date for which report is generated. The time part of target_datetime
     * will be zero till we support multiple reports per day.
     *
     * Generated from protobuf field <code>.google.type.DateTime target_datetime = 6;</code>
     * @param \Google\Type\DateTime $var
     * @return $this
     */
    public function setTargetDatetime($var)
    {
        GPBUtil::checkMessage($var, \Google\Type\DateTime::class);
        $this->target_datetime = $var;

        return $this;
    }

    /**
     * Metrics of the report.
     *
     * Generated from protobuf field <code>.google.cloud.storageinsights.v1.ReportDetail.Metrics report_metrics = 7;</code>
     * @return \Google\Cloud\StorageInsights\V1\ReportDetail\Metrics|null
     */
    public function getReportMetrics()
    {
        return $this->report_metrics;
    }

    public function hasReportMetrics()
    {
        return isset($this->report_metrics);
    }

    public function clearReportMetrics()
    {
        unset($this->report_metrics);
    }

    /**
     * Metrics of the report.
     *
     * Generated from protobuf field <code>.google.cloud.storageinsights.v1.ReportDetail.Metrics report_metrics = 7;</code>
     * @param \Google\Cloud\StorageInsights\V1\ReportDetail\Metrics $var
     * @return $this
     */
    public function setReportMetrics($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\StorageInsights\V1\ReportDetail\Metrics::class);
        $this->report_metrics = $var;

        return $this;
    }

}

