<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/vmmigration/v1/vmmigration.proto

namespace Google\Cloud\VMMigration\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for 'CreateUtilizationReport' request.
 *
 * Generated from protobuf message <code>google.cloud.vmmigration.v1.CreateUtilizationReportRequest</code>
 */
class CreateUtilizationReportRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The Utilization Report's parent.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $parent = '';
    /**
     * Required. The report to create.
     *
     * Generated from protobuf field <code>.google.cloud.vmmigration.v1.UtilizationReport utilization_report = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $utilization_report = null;
    /**
     * Required. The ID to use for the report, which will become the final
     * component of the reports's resource name.
     * This value maximum length is 63 characters, and valid characters
     * are /[a-z][0-9]-/. It must start with an english letter and must not
     * end with a hyphen.
     *
     * Generated from protobuf field <code>string utilization_report_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $utilization_report_id = '';
    /**
     * A request ID to identify requests. Specify a unique request ID
     * so that if you must retry your request, the server will know to ignore
     * the request if it has already been completed. The server will guarantee
     * that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and t
     * he request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4;</code>
     */
    private $request_id = '';

    /**
     * @param string                                         $parent              Required. The Utilization Report's parent. Please see
     *                                                                            {@see VmMigrationClient::sourceName()} for help formatting this field.
     * @param \Google\Cloud\VMMigration\V1\UtilizationReport $utilizationReport   Required. The report to create.
     * @param string                                         $utilizationReportId Required. The ID to use for the report, which will become the final
     *                                                                            component of the reports's resource name.
     *
     *                                                                            This value maximum length is 63 characters, and valid characters
     *                                                                            are /[a-z][0-9]-/. It must start with an english letter and must not
     *                                                                            end with a hyphen.
     *
     * @return \Google\Cloud\VMMigration\V1\CreateUtilizationReportRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\VMMigration\V1\UtilizationReport $utilizationReport, string $utilizationReportId): self
    {
        return (new self())
            ->setParent($parent)
            ->setUtilizationReport($utilizationReport)
            ->setUtilizationReportId($utilizationReportId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The Utilization Report's parent.
     *     @type \Google\Cloud\VMMigration\V1\UtilizationReport $utilization_report
     *           Required. The report to create.
     *     @type string $utilization_report_id
     *           Required. The ID to use for the report, which will become the final
     *           component of the reports's resource name.
     *           This value maximum length is 63 characters, and valid characters
     *           are /[a-z][0-9]-/. It must start with an english letter and must not
     *           end with a hyphen.
     *     @type string $request_id
     *           A request ID to identify requests. Specify a unique request ID
     *           so that if you must retry your request, the server will know to ignore
     *           the request if it has already been completed. The server will guarantee
     *           that for at least 60 minutes since the first request.
     *           For example, consider a situation where you make an initial request and t
     *           he request times out. If you make the request again with the same request
     *           ID, the server can check if original operation with the same request ID
     *           was received, and if so, will ignore the second request. This prevents
     *           clients from accidentally creating duplicate commitments.
     *           The request ID must be a valid UUID with the exception that zero UUID is
     *           not supported (00000000-0000-0000-0000-000000000000).
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Vmmigration\V1\Vmmigration::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The Utilization Report's parent.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The Utilization Report's parent.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The report to create.
     *
     * Generated from protobuf field <code>.google.cloud.vmmigration.v1.UtilizationReport utilization_report = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\VMMigration\V1\UtilizationReport|null
     */
    public function getUtilizationReport()
    {
        return $this->utilization_report;
    }

    public function hasUtilizationReport()
    {
        return isset($this->utilization_report);
    }

    public function clearUtilizationReport()
    {
        unset($this->utilization_report);
    }

    /**
     * Required. The report to create.
     *
     * Generated from protobuf field <code>.google.cloud.vmmigration.v1.UtilizationReport utilization_report = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\VMMigration\V1\UtilizationReport $var
     * @return $this
     */
    public function setUtilizationReport($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\VMMigration\V1\UtilizationReport::class);
        $this->utilization_report = $var;

        return $this;
    }

    /**
     * Required. The ID to use for the report, which will become the final
     * component of the reports's resource name.
     * This value maximum length is 63 characters, and valid characters
     * are /[a-z][0-9]-/. It must start with an english letter and must not
     * end with a hyphen.
     *
     * Generated from protobuf field <code>string utilization_report_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getUtilizationReportId()
    {
        return $this->utilization_report_id;
    }

    /**
     * Required. The ID to use for the report, which will become the final
     * component of the reports's resource name.
     * This value maximum length is 63 characters, and valid characters
     * are /[a-z][0-9]-/. It must start with an english letter and must not
     * end with a hyphen.
     *
     * Generated from protobuf field <code>string utilization_report_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setUtilizationReportId($var)
    {
        GPBUtil::checkString($var, True);
        $this->utilization_report_id = $var;

        return $this;
    }

    /**
     * A request ID to identify requests. Specify a unique request ID
     * so that if you must retry your request, the server will know to ignore
     * the request if it has already been completed. The server will guarantee
     * that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and t
     * he request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4;</code>
     * @return string
     */
    public function getRequestId()
    {
        return $this->request_id;
    }

    /**
     * A request ID to identify requests. Specify a unique request ID
     * so that if you must retry your request, the server will know to ignore
     * the request if it has already been completed. The server will guarantee
     * that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and t
     * he request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setRequestId($var)
    {
        GPBUtil::checkString($var, True);
        $this->request_id = $var;

        return $this;
    }

}

