<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: grafeas/v1/vex.proto

namespace Grafeas\V1\VulnerabilityAssessmentNote;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Assessment provides all information that is related to a single
 * vulnerability for this product.
 *
 * Generated from protobuf message <code>grafeas.v1.VulnerabilityAssessmentNote.Assessment</code>
 */
class Assessment extends \Google\Protobuf\Internal\Message
{
    /**
     * Holds the MITRE standard Common Vulnerabilities and Exposures (CVE)
     * tracking number for the vulnerability.
     *
     * Generated from protobuf field <code>string cve = 1;</code>
     */
    private $cve = '';
    /**
     * A one sentence description of this Vex.
     *
     * Generated from protobuf field <code>string short_description = 2;</code>
     */
    private $short_description = '';
    /**
     * A detailed description of this Vex.
     *
     * Generated from protobuf field <code>string long_description = 3;</code>
     */
    private $long_description = '';
    /**
     * Holds a list of references associated with this vulnerability item and
     * assessment. These uris have additional information about the
     * vulnerability and the assessment itself. E.g. Link to a document which
     * details how this assessment concluded the state of this vulnerability.
     *
     * Generated from protobuf field <code>repeated .grafeas.v1.RelatedUrl related_uris = 4;</code>
     */
    private $related_uris;
    /**
     * Provides the state of this Vulnerability assessment.
     *
     * Generated from protobuf field <code>.grafeas.v1.VulnerabilityAssessmentNote.Assessment.State state = 5;</code>
     */
    private $state = 0;
    /**
     * Contains information about the impact of this vulnerability,
     * this will change with time.
     *
     * Generated from protobuf field <code>repeated string impacts = 6;</code>
     */
    private $impacts;
    /**
     * Justification provides the justification when the state of the
     * assessment if NOT_AFFECTED.
     *
     * Generated from protobuf field <code>.grafeas.v1.VulnerabilityAssessmentNote.Assessment.Justification justification = 7;</code>
     */
    private $justification = null;
    /**
     * Specifies details on how to handle (and presumably, fix) a vulnerability.
     *
     * Generated from protobuf field <code>repeated .grafeas.v1.VulnerabilityAssessmentNote.Assessment.Remediation remediations = 8;</code>
     */
    private $remediations;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $cve
     *           Holds the MITRE standard Common Vulnerabilities and Exposures (CVE)
     *           tracking number for the vulnerability.
     *     @type string $short_description
     *           A one sentence description of this Vex.
     *     @type string $long_description
     *           A detailed description of this Vex.
     *     @type array<\Grafeas\V1\RelatedUrl>|\Google\Protobuf\Internal\RepeatedField $related_uris
     *           Holds a list of references associated with this vulnerability item and
     *           assessment. These uris have additional information about the
     *           vulnerability and the assessment itself. E.g. Link to a document which
     *           details how this assessment concluded the state of this vulnerability.
     *     @type int $state
     *           Provides the state of this Vulnerability assessment.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $impacts
     *           Contains information about the impact of this vulnerability,
     *           this will change with time.
     *     @type \Grafeas\V1\VulnerabilityAssessmentNote\Assessment\Justification $justification
     *           Justification provides the justification when the state of the
     *           assessment if NOT_AFFECTED.
     *     @type array<\Grafeas\V1\VulnerabilityAssessmentNote\Assessment\Remediation>|\Google\Protobuf\Internal\RepeatedField $remediations
     *           Specifies details on how to handle (and presumably, fix) a vulnerability.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Grafeas\V1\Vex::initOnce();
        parent::__construct($data);
    }

    /**
     * Holds the MITRE standard Common Vulnerabilities and Exposures (CVE)
     * tracking number for the vulnerability.
     *
     * Generated from protobuf field <code>string cve = 1;</code>
     * @return string
     */
    public function getCve()
    {
        return $this->cve;
    }

    /**
     * Holds the MITRE standard Common Vulnerabilities and Exposures (CVE)
     * tracking number for the vulnerability.
     *
     * Generated from protobuf field <code>string cve = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setCve($var)
    {
        GPBUtil::checkString($var, True);
        $this->cve = $var;

        return $this;
    }

    /**
     * A one sentence description of this Vex.
     *
     * Generated from protobuf field <code>string short_description = 2;</code>
     * @return string
     */
    public function getShortDescription()
    {
        return $this->short_description;
    }

    /**
     * A one sentence description of this Vex.
     *
     * Generated from protobuf field <code>string short_description = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setShortDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->short_description = $var;

        return $this;
    }

    /**
     * A detailed description of this Vex.
     *
     * Generated from protobuf field <code>string long_description = 3;</code>
     * @return string
     */
    public function getLongDescription()
    {
        return $this->long_description;
    }

    /**
     * A detailed description of this Vex.
     *
     * Generated from protobuf field <code>string long_description = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setLongDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->long_description = $var;

        return $this;
    }

    /**
     * Holds a list of references associated with this vulnerability item and
     * assessment. These uris have additional information about the
     * vulnerability and the assessment itself. E.g. Link to a document which
     * details how this assessment concluded the state of this vulnerability.
     *
     * Generated from protobuf field <code>repeated .grafeas.v1.RelatedUrl related_uris = 4;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getRelatedUris()
    {
        return $this->related_uris;
    }

    /**
     * Holds a list of references associated with this vulnerability item and
     * assessment. These uris have additional information about the
     * vulnerability and the assessment itself. E.g. Link to a document which
     * details how this assessment concluded the state of this vulnerability.
     *
     * Generated from protobuf field <code>repeated .grafeas.v1.RelatedUrl related_uris = 4;</code>
     * @param array<\Grafeas\V1\RelatedUrl>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setRelatedUris($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Grafeas\V1\RelatedUrl::class);
        $this->related_uris = $arr;

        return $this;
    }

    /**
     * Provides the state of this Vulnerability assessment.
     *
     * Generated from protobuf field <code>.grafeas.v1.VulnerabilityAssessmentNote.Assessment.State state = 5;</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * Provides the state of this Vulnerability assessment.
     *
     * Generated from protobuf field <code>.grafeas.v1.VulnerabilityAssessmentNote.Assessment.State state = 5;</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Grafeas\V1\VulnerabilityAssessmentNote\Assessment\State::class);
        $this->state = $var;

        return $this;
    }

    /**
     * Contains information about the impact of this vulnerability,
     * this will change with time.
     *
     * Generated from protobuf field <code>repeated string impacts = 6;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getImpacts()
    {
        return $this->impacts;
    }

    /**
     * Contains information about the impact of this vulnerability,
     * this will change with time.
     *
     * Generated from protobuf field <code>repeated string impacts = 6;</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setImpacts($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->impacts = $arr;

        return $this;
    }

    /**
     * Justification provides the justification when the state of the
     * assessment if NOT_AFFECTED.
     *
     * Generated from protobuf field <code>.grafeas.v1.VulnerabilityAssessmentNote.Assessment.Justification justification = 7;</code>
     * @return \Grafeas\V1\VulnerabilityAssessmentNote\Assessment\Justification|null
     */
    public function getJustification()
    {
        return $this->justification;
    }

    public function hasJustification()
    {
        return isset($this->justification);
    }

    public function clearJustification()
    {
        unset($this->justification);
    }

    /**
     * Justification provides the justification when the state of the
     * assessment if NOT_AFFECTED.
     *
     * Generated from protobuf field <code>.grafeas.v1.VulnerabilityAssessmentNote.Assessment.Justification justification = 7;</code>
     * @param \Grafeas\V1\VulnerabilityAssessmentNote\Assessment\Justification $var
     * @return $this
     */
    public function setJustification($var)
    {
        GPBUtil::checkMessage($var, \Grafeas\V1\VulnerabilityAssessmentNote\Assessment\Justification::class);
        $this->justification = $var;

        return $this;
    }

    /**
     * Specifies details on how to handle (and presumably, fix) a vulnerability.
     *
     * Generated from protobuf field <code>repeated .grafeas.v1.VulnerabilityAssessmentNote.Assessment.Remediation remediations = 8;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getRemediations()
    {
        return $this->remediations;
    }

    /**
     * Specifies details on how to handle (and presumably, fix) a vulnerability.
     *
     * Generated from protobuf field <code>repeated .grafeas.v1.VulnerabilityAssessmentNote.Assessment.Remediation remediations = 8;</code>
     * @param array<\Grafeas\V1\VulnerabilityAssessmentNote\Assessment\Remediation>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setRemediations($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Grafeas\V1\VulnerabilityAssessmentNote\Assessment\Remediation::class);
        $this->remediations = $arr;

        return $this;
    }

}


